#include "stdafx.h"
#include <math.h>	// for log10
#include <shlwapi.h>
#include "DtvEngine.h"
#include "HDUSTest_KeyHook/HDUSTest_KeyHook.h"
#include "ChannelList.h"
#include "NetworkRemocon.h"
#include "Settings.h"
#include "Image.h"
#include "resource.h"


#pragma warning(disable: 4995) // warning C4995: Oꂽ #pragma ƂċLqĂ܂B


#define lengthof(a) (sizeof(a)/sizeof(a[0]))


#define MAIN_WINDOW_CLASS				TEXT("HDUSTest Window")
#define VIEW_WINDOW_CLASS				TEXT("HDUSTest View")
#define VIDEO_CONTAINER_WINDOW_CLASS	TEXT("HDUSTest Video Container")
#define FULLSCREEN_WINDOW_CLASS			TEXT("HDUSTest Fullscreen")
#define STATUS_WINDOW_CLASS				TEXT("HDUSTest Status")

#define TITLE_TEXT TEXT("HDUSTest")

#define TIMER_ID_UPDATE		1
#define TIMER_ID_DISPLAY	2

#define STATUS_MARGIN	4

#define MENU_POS_ZOOM			0
#define MENU_POS_ASPECTRATIO	1
#define MENU_POS_CHANNEL		5
#define MENU_POS_SERVICE		6
#define MENU_POS_SPACE			7
#define MENU_POS_VOLUME			9
#define MENU_POS_STEREOMODE		10

static HINSTANCE hInst;
static HWND hwndMain;
static HWND hwndView;
static HWND hwndVideoContainer;
static HMENU hmenuMain=NULL;
static HACCEL hAccel;

static int WindowLeft=CW_USEDEFAULT;
static int WindowTop=CW_USEDEFAULT;
static int WindowWidth=CW_USEDEFAULT;
static int WindowHeight=CW_USEDEFAULT;
static bool fWindowMaximize=false;
static bool fAlwaysOnTop=false;
static bool fFullscreen=false;

static TCHAR szIniFileName[MAX_PATH];
static TCHAR szDriverFileName[MAX_PATH];
static TCHAR szTempDriverFileName[MAX_PATH];
static HMODULE hDriverLib=NULL;
static bool fUDPDriver=false;

static TCHAR szChannelListFileName[MAX_PATH];
static CChannelList ChannelList;

static bool fNoDescramble=false;
static bool fTempNoDescramble=false;
static bool fNoKeyHook=false;
static bool fNoRemoteController=false;
static bool fNoScreenSaver=false;
static BOOL fScreenSaverActive=FALSE;
static bool fNoMonitorLowPower=false;
static bool fNoMonitorLowPowerActiveOnly=false;
static BOOL fLowPowerActiveOriginal=FALSE,fPowerOffActiveOriginal=FALSE;
static bool fRestoreChannel=false;
static int OldChannel=0,OldSpace=-1;
static bool fAdjustAspectResizing=false;
static bool fConfirmRecChannelChange=false;
static bool fUseVMR9=false;

static CDtvEngine DtvEngine;

static int NumSpaces=0;
static int CurrentSpace=0;
static int CurrentChannel=-1;
static int CurrentService=0;
#define MAX_VOLUME 100
static int CurrentVolume=100;
static bool fMute=false;
static int CurrentStereoMode=0;
static DWORD ErrorPacketCount=0;
static DWORD ScramblePacketCount=0;

static const int ZoomList[] = {25,33,50,66,75,100,150,200};
static int AspectRatioType=0;
static int VideoWidth=0;
static int VideoHeight=0;
static int PanAndScanVideoWidth=0;
static int PanAndScanVideoHeight=0;
static int CurrentNumAudioChannels=0;
static bool fRecording=false;
static TCHAR szRecordFileName[MAX_PATH];
static bool fAddRecordTime=false;

static COLORREF crStatusBkColor=RGB(128,192,160);
static COLORREF crStatusTextColor=RGB(64,96,80);

static POINT ptDragStartPos;
static RECT rcDragStart;

static bool fUseNetworkRemocon=false;
static bool fUseNetworkRemoconCmd=false;
static char szNetworkRemoconAddress[16] = "127.0.0.1";
static unsigned int NetworkRemoconPort=0;
static CNetworkRemocon *pNetworkRemocon=NULL;
static TCHAR szNetworkRemoconChFile[MAX_PATH];
static int NetworkRemoconCurChannelNo=0;




static bool LoadSettings()
{
	Settings Setting;

	if (Setting.Open(szIniFileName,TEXT("Settings"),Settings::OPEN_READ)) {
		int Value;
		TCHAR szAddress[16];

		Setting.Read(TEXT("WindowLeft"),&WindowLeft);
		Setting.Read(TEXT("WindowTop"),&WindowTop);
		Setting.Read(TEXT("WindowWidth"),&WindowWidth);
		Setting.Read(TEXT("WindowHeight"),&WindowHeight);
		Setting.Read(TEXT("WindowMaximize"),&fWindowMaximize);
		Setting.Read(TEXT("AlwaysOnTop"),&fAlwaysOnTop);
		Setting.Read(TEXT("Driver"),szDriverFileName,
												lengthof(szDriverFileName));
		if (Setting.Read(TEXT("Volume"),&Value))
			CurrentVolume=Value<0?0:Value>MAX_VOLUME?MAX_VOLUME:Value;
		Setting.Read(TEXT("RecordFile"),szRecordFileName,
												lengthof(szRecordFileName));
		Setting.Read(TEXT("AddRecordTime"),&fAddRecordTime);
		Setting.ReadColor(TEXT("StatusBkColor"),&crStatusBkColor);
		Setting.ReadColor(TEXT("StatusTextColor"),&crStatusTextColor);
		Setting.Read(TEXT("NoRemoteController"),&fNoRemoteController);
		Setting.Read(TEXT("NoKeyHook"),&fNoKeyHook);
		Setting.Read(TEXT("NoScreenSaver"),&fNoScreenSaver);
		Setting.Read(TEXT("NoMonitorLowPower"),&fNoMonitorLowPower);
		Setting.Read(TEXT("NoMonitorLowPowerActiveOnly"),
												&fNoMonitorLowPowerActiveOnly);
		Setting.Read(TEXT("AdjustAspectResizing"),&fAdjustAspectResizing);
		Setting.Read(TEXT("NoDescramble"),&fNoDescramble);
		Setting.Read(TEXT("RestoreChannel"),&fRestoreChannel);
		Setting.Read(TEXT("CurChannel"),&OldChannel);
		Setting.Read(TEXT("CurSpace"),&OldSpace);
		Setting.Read(TEXT("ConfirmRecChChange"),&fConfirmRecChannelChange);
		Setting.Read(TEXT("UseNetworkRemocon"),&fUseNetworkRemocon);
		if (Setting.Read(TEXT("NetworkRemoconAddress"),szAddress,16))
			WideCharToMultiByte(CP_ACP,0,szAddress,-1,szNetworkRemoconAddress,
								lengthof(szNetworkRemoconAddress),NULL,NULL);
		Setting.Read(TEXT("NetworkRemoconPort"),&NetworkRemoconPort);
		Setting.Read(TEXT("NetworkRemoconChFile"),szNetworkRemoconChFile,
											lengthof(szNetworkRemoconChFile));
		TCHAR szRenderer[16];
		if (Setting.Read(TEXT("Renderer"),szRenderer,lengthof(szRenderer))) {
			fUseVMR9=lstrcmpi(szRenderer,TEXT("VMR9"))==0;
		}
		Setting.Close();
		return true;
	}
	return false;
}


static bool SaveSettings()
{
	Settings Setting;

	if (Setting.Open(szIniFileName,TEXT("Settings"),Settings::OPEN_WRITE)) {
		int Value;

		Setting.Write(TEXT("WindowLeft"),WindowLeft);
		Setting.Write(TEXT("WindowTop"),WindowTop);
		Setting.Write(TEXT("WindowWidth"),WindowWidth);
		Setting.Write(TEXT("WindowHeight"),WindowHeight);
		Setting.Write(TEXT("WindowMaximize"),fWindowMaximize);
		Setting.Write(TEXT("AlwaysOnTop"),fAlwaysOnTop);
		Setting.Write(TEXT("Driver"),szDriverFileName);
		Setting.Write(TEXT("Volume"),CurrentVolume);
		Setting.Write(TEXT("RecordFile"),szRecordFileName);
		Setting.Write(TEXT("AddRecordTime"),fAddRecordTime);
		Setting.WriteColor(TEXT("StatusBkColor"),crStatusBkColor);
		Setting.WriteColor(TEXT("StatusTextColor"),crStatusTextColor);
		Setting.Write(TEXT("NoRemoteController"),fNoRemoteController);
		Setting.Write(TEXT("NoKeyHook"),fNoKeyHook);
		Setting.Write(TEXT("NoScreenSaver"),fNoScreenSaver);
		Setting.Write(TEXT("NoMonitorLowPower"),fNoMonitorLowPower);
		Setting.Write(TEXT("NoMonitorLowPowerActiveOnly"),
												fNoMonitorLowPowerActiveOnly);
		Setting.Write(TEXT("AdjustAspectResizing"),fAdjustAspectResizing);
		Setting.Write(TEXT("NoDescramble"),fNoDescramble);
		Setting.Write(TEXT("RestoreChannel"),fRestoreChannel);
		Setting.Write(TEXT("CurChannel"),OldChannel);
		Setting.Write(TEXT("CurSpace"),OldSpace);
		Setting.Write(TEXT("ConfirmRecChChange"),fConfirmRecChannelChange);
		Setting.Write(TEXT("UseNetworkRemocon"),fUseNetworkRemocon);
		TCHAR szAddress[16];
		MultiByteToWideChar(CP_ACP,0,szNetworkRemoconAddress,-1,
												szAddress,lengthof(szAddress));
		Setting.Write(TEXT("NetworkRemoconAddress"),szAddress);
		Setting.Write(TEXT("NetworkRemoconPort"),NetworkRemoconPort);
		Setting.Write(TEXT("NetworkRemoconChFile"),szNetworkRemoconChFile);
		Setting.Close();
		return true;
	}
	return false;
}


static void GetNetworkRemoconChFilePath(LPCTSTR pszFileName,LPTSTR pszPath)
{
	if (pszFileName[0]=='\0') {
		lstrcpy(pszPath,TEXT("BonDriver_HDUS(HDUS).ChSet.txt"));
	} else if (PathIsRelative(pszFileName)) {
		SHGetSpecialFolderPath(NULL,pszPath,CSIDL_PERSONAL,FALSE);
		PathAppend(pszPath,TEXT("EpgTimerBon"));
		PathAppend(pszPath,pszFileName);
	} else
		lstrcpy(pszPath,pszFileName);
}


static float LevelToDeciBel(int Level)
{
	float Volume;

	if (Level==0)
		Volume=-100.0f;
	else
		Volume=(float)(20.0*log10((double)Level/100.0));
	return Volume;
}


static void AdjustAspect(int *pWidth,int *pHeight,int XAspect,int YAspect)
{
	int Width=*pWidth,Height=*pHeight;
	/*
	double SrcAspect,DstAspect;

	SrcAspect=(double)Width/(double)Height;
	DstAspect=(double)XAspect/(double)YAspect;
	if (SrcAspect<DstAspect)
		Height=Width*YAspect/XAspect;
	else if (SrcAspect>DstAspect)
		Width=Height*XAspect/YAspect;
	*/
	Width=Height*XAspect/YAspect;
	*pWidth=Width;
	*pHeight=Height;
}


static int CalcZoomRate()
{
	RECT rc;
	int Zoom;

	if (PanAndScanVideoWidth>0 && PanAndScanVideoHeight>0) {
		int Width,Height;
		BYTE XAspect,YAspect;

		GetClientRect(hwndView,&rc);
		Width=PanAndScanVideoWidth;
		Height=PanAndScanVideoHeight;
		if (DtvEngine.m_MediaViewer.GetEffectiveAspectRatio(&XAspect,&YAspect))
			AdjustAspect(&Width,&Height,XAspect,YAspect);
		Zoom=(rc.bottom*100+Height/2)/Height;
	} else
		Zoom=0;
	return Zoom;
}


static void SetDisplayStatus()
{
	if (!fNoScreenSaver && fScreenSaverActive) {
		SystemParametersInfo(SPI_SETSCREENSAVEACTIVE,TRUE,NULL,0);
		fScreenSaverActive=FALSE;
	}
	if (!fNoMonitorLowPower) {
		if (fPowerOffActiveOriginal) {
			SystemParametersInfo(SPI_SETPOWEROFFACTIVE,TRUE,NULL,
								SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
			fPowerOffActiveOriginal=FALSE;
		}
		if (fLowPowerActiveOriginal) {
			SystemParametersInfo(SPI_SETLOWPOWERACTIVE,TRUE,NULL,
								SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
			fLowPowerActiveOriginal=FALSE;
		}
	}
	if (fNoScreenSaver && fNoMonitorLowPower && !fNoMonitorLowPowerActiveOnly) {
		// SetThreadExecutionState() Ăԃ^C}[
		SetTimer(hwndMain,TIMER_ID_DISPLAY,30000,NULL);
	} else {
		KillTimer(hwndMain,TIMER_ID_DISPLAY);
		if (fNoScreenSaver && !fScreenSaverActive) {
			if (!SystemParametersInfo(SPI_GETSCREENSAVEACTIVE,0,
														&fScreenSaverActive,0))
				fScreenSaverActive=FALSE;
			if (fScreenSaverActive)
				SystemParametersInfo(SPI_SETSCREENSAVEACTIVE,FALSE,NULL,0);
		}
		if (fNoMonitorLowPower && !fNoMonitorLowPowerActiveOnly) {
			if (!fPowerOffActiveOriginal) {
				if (!SystemParametersInfo(SPI_GETPOWEROFFACTIVE,0,
												&fPowerOffActiveOriginal,0))
					fPowerOffActiveOriginal=FALSE;
				if (fPowerOffActiveOriginal)
					SystemParametersInfo(SPI_SETPOWEROFFACTIVE,FALSE,NULL,
								SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
			}
			if (!fLowPowerActiveOriginal) {
				if (!SystemParametersInfo(SPI_GETLOWPOWERACTIVE,0,
												&fLowPowerActiveOriginal,0))
					fLowPowerActiveOriginal=FALSE;
				if (fLowPowerActiveOriginal)
					SystemParametersInfo(SPI_SETLOWPOWERACTIVE,FALSE,NULL,
								SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
			}
		}
	}
}




static bool LoadChannelList(CChannelList *pList,LPCTSTR pszFileName)
{
	HANDLE hFile;
	DWORD Size,Read;
	char *pszText,*p,*q;
	TCHAR szName[MAX_CHANNEL_NAME];
	int i;
	int Space,ChannelNo,Channel;

	hFile=CreateFile(pszFileName,GENERIC_READ,FILE_SHARE_READ,NULL,
														OPEN_EXISTING,0,NULL);
	if (hFile==INVALID_HANDLE_VALUE)
		return false;
	Size=GetFileSize(hFile,NULL);
	if (Size==0) {
		CloseHandle(hFile);
		return false;
	}
	pszText=new char[Size+1];
	if (!ReadFile(hFile,pszText,Size,&Read,NULL) || Read!=Size) {
		delete [] pszText;
		CloseHandle(hFile);
		return false;
	}
	CloseHandle(hFile);
	pszText[Size]='\0';
	p=pszText;
	do {
		while (*p=='\r' || *p=='\n')
			p++;
		if (*p=='\0')
			break;
		q=p;
		while (*p!=',' && *p!='\0') {
			if (IsDBCSLeadByteEx(CP_ACP,*p) && *(p+1)!='\0')
				p++;
			p++;
		}
		if (*p!=',')
			break;
		*p++='\0';
#ifdef UNICODE
		MultiByteToWideChar(CP_ACP,0,q,-1,szName,MAX_CHANNEL_NAME);
#else
		lstrcpyn(szName,q,MAX_CHANNEL_NAME);
#endif
		ChannelNo=0;
		while (*p>='0' && *p<='9') {
			ChannelNo=ChannelNo*10+(*p-'0');
			p++;
		}
		if (*p!=',')
			break;
		p++;
		if (*p=='C') {
			Space=1;
			p++;
		} else
			Space=0;
		Channel=0;
		while (*p>='0' && *p<='9') {
			Channel=Channel*10+(*p-'0');
			p++;
		}
		if (ChannelNo>0 && Channel>0)
			pList->AddChannel(Space,Channel,ChannelNo,szName);
		while (*p!='\r' && *p!='\n' && *p!='\0')
			p++;
	} while (*p!='\0');
	return true;
}



class CStatusItem {
protected:
	class CStatusView *m_pStatus;
	int m_Width;
public:
	virtual ~CStatusItem() {}
	virtual void Draw(HDC hdc,const RECT *pRect)=0;
	int Width() const { return m_Width; }
	virtual void OnLButtonDown(int x,int y) {}
	virtual void OnRButtonDown(int x,int y) { OnLButtonDown(x,y); }
	virtual void OnMouseMove(int x,int y) {}
};


class CStatusView {
	HWND m_hwnd;
	HFONT m_hfontStatus;
	COLORREF m_crBackColor;
	COLORREF m_crTextColor;
#define NUM_STATUS_ITEMS 6
	CStatusItem *m_pItemList[6];
	bool m_fSingleMode;
	LPTSTR m_pszSingleText;
	int m_HotItem;
	bool m_fTrackMouseEvent;
	static CStatusView *GetStatusView(HWND hwnd);
	static LRESULT CALLBACK WndProc(HWND hwnd,UINT uMsg,
												WPARAM wParam,LPARAM lParam);
public:
	static bool Init();
	CStatusView();
	~CStatusView();
	bool Create(HWND hwndParent,int ID,DWORD Style,DWORD ExStyle);
	void UpdateItem(int Index);
	bool GetItemRect(int Index,RECT *pRect) const;
	void GetRect(RECT *pRect) const;
	int Height() const;
	void Move(int x,int y,int Width,int Height);
	HWND GetHandle() const { return m_hwnd; }
	void SetSingleText(LPCTSTR pszText);
	void SetColor(COLORREF crBack,COLORREF crText);
};

enum {
	STATUS_ITEM_CHANNEL,
	STATUS_ITEM_VIDEOSIZE,
	STATUS_ITEM_VOLUME,
	STATUS_ITEM_AUDIOCHANNEL,
	STATUS_ITEM_RECORD,
	STATUS_ITEM_ERROR
};


class CChannelStatusItem : public CStatusItem {
public:
	CChannelStatusItem(CStatusView *pStatus);
	void Draw(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
};

CChannelStatusItem::CChannelStatusItem(CStatusView *pStatus)
{
	m_pStatus=pStatus;
	m_Width=96;
}

void CChannelStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	TCHAR szText[4+MAX_CHANNEL_NAME];

	if (pNetworkRemocon!=NULL && NetworkRemoconCurChannelNo>0) {
		const CChannelList &List=pNetworkRemocon->GetChannelList();
		int i=List.FindChannelNo(NetworkRemoconCurChannelNo);

		wsprintf(szText,TEXT("%d: %s"),List.GetChannelNo(i),List.GetName(i));
	} else if (CurrentChannel>=0) {
		wsprintf(szText,TEXT("%d: %s"),
									ChannelList.GetChannelNo(CurrentChannel),
									ChannelList.GetName(CurrentChannel));
	} else
		lstrcpy(szText,TEXT("<`l>"));
	DrawText(hdc,szText,-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CChannelStatusItem::OnLButtonDown(int x,int y)
{
	RECT rc;
	POINT pt;

	m_pStatus->GetItemRect(STATUS_ITEM_CHANNEL,&rc);
	pt.x=rc.left;
	pt.y=rc.bottom;
	ClientToScreen(m_pStatus->GetHandle(),&pt);
	TrackPopupMenu(GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_CHANNEL),
									TPM_LEFTBUTTON,pt.x,pt.y,0,hwndMain,NULL);
}


class CVideoSizeStatusItem : public CStatusItem {
public:
	CVideoSizeStatusItem(CStatusView *pStatus);
	void Draw(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
};

CVideoSizeStatusItem::CVideoSizeStatusItem(CStatusView *pStatus)
{
	m_pStatus=pStatus;
	m_Width=120;
}

void CVideoSizeStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	TCHAR szText[32];
	wsprintf(szText,TEXT("%d x %d (%d %%)"),VideoWidth,VideoHeight,
															CalcZoomRate());
	DrawText(hdc,szText,-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CVideoSizeStatusItem::OnLButtonDown(int x,int y)
{
	RECT rc;
	POINT pt;

	m_pStatus->GetItemRect(STATUS_ITEM_VIDEOSIZE,&rc);
	pt.x=rc.left;
	pt.y=rc.bottom;
	ClientToScreen(m_pStatus->GetHandle(),&pt);
	TrackPopupMenu(GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_ZOOM),
									TPM_LEFTBUTTON,pt.x,pt.y,0,hwndMain,NULL);
}


class CVolumeStatusItem : public CStatusItem {
public:
	CVolumeStatusItem(CStatusView *pStatus);
	void Draw(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
	void OnRButtonDown(int x,int y);
	void OnMouseMove(int x,int y);
};

CVolumeStatusItem::CVolumeStatusItem(CStatusView *pStatus)
{
	m_pStatus=pStatus;
	m_Width=80;
}

void CVolumeStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	HPEN hpen,hpenOld;
	HBRUSH hbr,hbrOld;
	RECT rc;
	COLORREF crBar;

	hpen=CreatePen(PS_SOLID,1,GetTextColor(hdc));
	hpenOld=(HPEN)SelectObject(hdc,hpen);
	hbrOld=(HBRUSH)SelectObject(hdc,GetStockObject(NULL_BRUSH));
	rc.left=pRect->left;
	rc.top=pRect->top+(pRect->bottom-pRect->top-8)/2;
	rc.right=pRect->right;
	rc.bottom=rc.top+8;
	Rectangle(hdc,rc.left,rc.top,rc.right,rc.bottom);
	SelectObject(hdc,hbrOld);
	SelectObject(hdc,hpenOld);
	DeleteObject(hpen);
	if (!fMute) {
		crBar=GetTextColor(hdc);
	} else {
		COLORREF crText,crBk;

		crText=GetTextColor(hdc);
		crBk=GetBkColor(hdc);
		crBar=RGB((GetRValue(crText)+GetRValue(crBk))/2,
				  (GetGValue(crText)+GetGValue(crBk))/2,
				  (GetBValue(crText)+GetBValue(crBk))/2);
	}
	hbr=CreateSolidBrush(crBar);
	rc.left+=2;
	rc.top+=2;
	rc.right=rc.left+(rc.right-2-rc.left)*CurrentVolume/MAX_VOLUME;
	rc.bottom-=2;
	FillRect(hdc,&rc,hbr);
	DeleteObject(hbr);
}

void CVolumeStatusItem::OnLButtonDown(int x,int y)
{
	OnMouseMove(x,y);
	SetCapture(m_pStatus->GetHandle());
}

void CVolumeStatusItem::OnRButtonDown(int x,int y)
{
	SendMessage(hwndMain,WM_COMMAND,CM_VOLUME_MUTE,0);
}

void CVolumeStatusItem::OnMouseMove(int x,int y)
{
	RECT rc;
	int Volume;

	m_pStatus->GetItemRect(STATUS_ITEM_VOLUME,&rc);
	Volume=(x-2)*100/(rc.right-rc.left-4-1);
	if (Volume<0)
		Volume=0;
	else if (Volume>MAX_VOLUME)
		Volume=MAX_VOLUME;
	if (fMute || Volume!=CurrentVolume) {
		if (fMute) {
			fMute=false;
			CheckMenuItem(hmenuMain,CM_VOLUME_MUTE,
												MF_BYCOMMAND | MFS_UNCHECKED);
		}
		DtvEngine.SetVolume(LevelToDeciBel(Volume));
		CurrentVolume=Volume;
		m_pStatus->UpdateItem(STATUS_ITEM_VOLUME);
	}
}


class CAudioChannelStatusItem : public CStatusItem {
public:
	CAudioChannelStatusItem(CStatusView *pStatus);
	void Draw(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
	void OnRButtonDown(int x,int y);
};

CAudioChannelStatusItem::CAudioChannelStatusItem(CStatusView *pStatus)
{
	m_pStatus=pStatus;
	m_Width=64;
}

void CAudioChannelStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	TCHAR szText[32];

	if (CurrentNumAudioChannels>0) {
		switch (CurrentNumAudioChannels) {
		case 1:
			lstrcpy(szText,TEXT("Mono"));
			break;
		case 2:
			lstrcpy(szText,TEXT("Stereo"));
			if (CurrentStereoMode!=0)
				lstrcat(szText,CurrentStereoMode==1?TEXT("(L)"):TEXT("(R)"));
			break;
		case 6:
			lstrcpy(szText,TEXT("5.1ch"));
			break;
		default:
			wsprintf(szText,TEXT("%dch"),CurrentNumAudioChannels);
			break;
		}
	} else
		lstrcpy(szText,TEXT("<>"));
	DrawText(hdc,szText,-1,const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CAudioChannelStatusItem::OnLButtonDown(int x,int y)
{
	if (CurrentNumAudioChannels==2)
		SendMessage(hwndMain,WM_COMMAND,CM_STEREOMODE,0);
	else
		OnRButtonDown(x,y);
}

void CAudioChannelStatusItem::OnRButtonDown(int x,int y)
{
	RECT rc;
	POINT pt;

	m_pStatus->GetItemRect(STATUS_ITEM_AUDIOCHANNEL,&rc);
	pt.x=rc.left;
	pt.y=rc.bottom;
	ClientToScreen(m_pStatus->GetHandle(),&pt);
	TrackPopupMenu(GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_STEREOMODE),
									TPM_LEFTBUTTON,pt.x,pt.y,0,hwndMain,NULL);
}


class CRecordStatusItem : public CStatusItem {
public:
	CRecordStatusItem(CStatusView *pStatus);
	void Draw(HDC hdc,const RECT *pRect);
	void OnLButtonDown(int x,int y);
	void OnRButtonDown(int x,int y);
};

CRecordStatusItem::CRecordStatusItem(CStatusView *pStatus)
{
	m_pStatus=pStatus;
	m_Width=64;
}

void CRecordStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	DrawText(hdc,fRecording?TEXT(" ^撆"):TEXT(""),-1,
		const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}

void CRecordStatusItem::OnLButtonDown(int x,int y)
{
	SendMessage(hwndMain,WM_COMMAND,CM_RECORD,0);
}

void CRecordStatusItem::OnRButtonDown(int x,int y)
{
	HMENU hmenu;
	RECT rc;
	POINT pt;

	hmenu=LoadMenu(hInst,MAKEINTRESOURCE(IDM_RECORD));
	CheckMenuItem(hmenu,CM_ADDRECORDTIME,
					MF_BYCOMMAND | (fAddRecordTime?MFS_CHECKED:MFS_UNCHECKED));
	m_pStatus->GetItemRect(STATUS_ITEM_RECORD,&rc);
	pt.x=rc.left;
	pt.y=rc.bottom;
	ClientToScreen(m_pStatus->GetHandle(),&pt);
	TrackPopupMenu(GetSubMenu(hmenu,0),TPM_LEFTBUTTON,pt.x,pt.y,0,hwndMain,
																		NULL);
	DestroyMenu(hmenu);
}


class CErrorStatusItem : public CStatusItem {
public:
	CErrorStatusItem(CStatusView *pStatus);
	void Draw(HDC hdc,const RECT *pRect);
};

CErrorStatusItem::CErrorStatusItem(CStatusView *pStatus)
{
	m_pStatus=pStatus;
	m_Width=120;
}

void CErrorStatusItem::Draw(HDC hdc,const RECT *pRect)
{
	TCHAR szText[64];
	int Length;

	Length=wsprintf(szText,TEXT("E %u"),ErrorPacketCount);
	if (!fNoDescramble)
		wsprintf(szText+Length,TEXT(" / S %u"),ScramblePacketCount);
	DrawText(hdc,szText,-1,
		const_cast<LPRECT>(pRect),
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
}




bool CStatusView::Init()
{
	WNDCLASS wc;

	wc.style=0;
	wc.lpfnWndProc=WndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hInstance=hInst;
	wc.hIcon=NULL;
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=NULL;
	wc.lpszMenuName=NULL;
	wc.lpszClassName=STATUS_WINDOW_CLASS;
	return RegisterClass(&wc)!=0;
}


CStatusView::CStatusView()
{
	m_hwnd=NULL;
	m_hfontStatus=NULL;
	m_crBackColor=RGB(0,0,0);
	m_crTextColor=RGB(255,255,255);
	m_pItemList[0]=new CChannelStatusItem(this);
	m_pItemList[1]=new CVideoSizeStatusItem(this);
	m_pItemList[2]=new CVolumeStatusItem(this);
	m_pItemList[3]=new CAudioChannelStatusItem(this);
	m_pItemList[4]=new CRecordStatusItem(this);
	m_pItemList[5]=new CErrorStatusItem(this);
	m_fSingleMode=false;
	m_pszSingleText=NULL;
	m_HotItem=-1;
	m_fTrackMouseEvent=false;
}


CStatusView::~CStatusView()
{
	if (m_hwnd!=NULL)
		DestroyWindow(m_hwnd);
	for (int i=0;i<NUM_STATUS_ITEMS;i++)
		delete m_pItemList[i];
	delete [] m_pszSingleText;
}


bool CStatusView::Create(HWND hwndParent,int ID,DWORD Style,DWORD ExStyle)
{
	m_hwnd=CreateWindowEx(ExStyle,STATUS_WINDOW_CLASS,NULL,Style,
									0,0,0,0,hwndParent,(HMENU)ID,hInst,this);
	return m_hwnd!=NULL;
}


CStatusView *CStatusView::GetStatusView(HWND hwnd)
{
	return (CStatusView*)GetWindowLongPtr(hwnd,GWLP_USERDATA);
}


LRESULT CALLBACK CStatusView::WndProc(HWND hwnd,UINT uMsg,WPARAM wParam,
																LPARAM lParam)
{
	switch (uMsg) {
	case WM_CREATE:
		{
			LPCREATESTRUCT pcs=(LPCREATESTRUCT)lParam;
			CStatusView *pStatus;
			LOGFONT lf;
			HDC hdc;
			HFONT hfontOld;
			TEXTMETRIC tm;
			RECT rc;

			pStatus=(CStatusView*)pcs->lpCreateParams;
			SetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR)pStatus);
			GetObject(GetStockObject(DEFAULT_GUI_FONT),sizeof(LOGFONT),&lf);
			pStatus->m_hfontStatus=CreateFontIndirect(&lf);
			hdc=GetDC(hwnd);
			hfontOld=(HFONT)SelectObject(hdc,pStatus->m_hfontStatus);
			GetTextMetrics(hdc,&tm);
			SelectObject(hdc,hfontOld);
			ReleaseDC(hwnd,hdc);
			rc.left=0;
			rc.top=0;
			rc.right=0;
			rc.bottom=tm.tmHeight+STATUS_MARGIN*2;
			AdjustWindowRectEx(&rc,pcs->style,FALSE,pcs->dwExStyle);
			MoveWindow(hwnd,0,0,0,rc.bottom-rc.top,FALSE);
		}
		return 0;

	case WM_PAINT:
		{
			CStatusView *pStatus=GetStatusView(hwnd);
			PAINTSTRUCT ps;
			HBRUSH hbrBk,hbrHighlight;
			HFONT hfontOld;
			COLORREF crOldTextColor,crOldBkColor;
			int OldBkMode;
			RECT rc;
			TCHAR szText[64];
			int i;
			int x;

			BeginPaint(hwnd,&ps);
			hfontOld=(HFONT)SelectObject(ps.hdc,pStatus->m_hfontStatus);
			OldBkMode=SetBkMode(ps.hdc,TRANSPARENT);
			hbrBk=CreateSolidBrush(crStatusBkColor);
			if (pStatus->m_HotItem>=0)
				hbrHighlight=CreateSolidBrush(crStatusTextColor);
			else
				hbrHighlight=NULL;
			crOldTextColor=GetTextColor(ps.hdc);
			crOldBkColor=GetBkColor(ps.hdc);
			GetClientRect(hwnd,&rc);
			if (pStatus->m_fSingleMode) {
				FillRect(ps.hdc,&ps.rcPaint,hbrBk);
				SetTextColor(ps.hdc,crStatusTextColor);
				rc.left+=STATUS_MARGIN;
				DrawText(ps.hdc,pStatus->m_pszSingleText,-1,&rc,
						DT_LEFT | DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX);
			} else {
				for (i=0;i<NUM_STATUS_ITEMS;i++) {
					SetTextColor(ps.hdc,i==pStatus->m_HotItem?
										crStatusBkColor:crStatusTextColor);
					SetBkColor(ps.hdc,i==pStatus->m_HotItem?
										crStatusTextColor:crStatusBkColor);
					rc.right=rc.left+pStatus->m_pItemList[i]->Width()+
															STATUS_MARGIN*2;
					FillRect(ps.hdc,&rc,i==pStatus->m_HotItem?hbrHighlight:hbrBk);
					rc.left+=STATUS_MARGIN;
					rc.right-=STATUS_MARGIN;
					pStatus->m_pItemList[i]->Draw(ps.hdc,&rc);
					rc.left=rc.right+STATUS_MARGIN;
				}
				rc.right=ps.rcPaint.right;
				if (rc.right>rc.left)
					FillRect(ps.hdc,&rc,hbrBk);
			}
			DeleteObject(hbrBk);
			if (hbrHighlight!=NULL)
				DeleteObject(hbrHighlight);
			SetBkColor(ps.hdc,crOldBkColor);
			SetTextColor(ps.hdc,crOldTextColor);
			SetBkMode(ps.hdc,OldBkMode);
			SelectObject(ps.hdc,hfontOld);
			EndPaint(hwnd,&ps);
		}
		return 0;

	case WM_MOUSEMOVE:
		if (GetCapture()==hwnd) {
			CStatusView *pStatus=GetStatusView(hwnd);
			int x=GET_X_LPARAM(lParam),y=GET_Y_LPARAM(lParam);
			RECT rc;

			pStatus->GetItemRect(pStatus->m_HotItem,&rc);
			x-=rc.left;
			pStatus->m_pItemList[pStatus->m_HotItem]->OnMouseMove(x,y);
		} else {
			CStatusView *pStatus=GetStatusView(hwnd);
			int x=GET_X_LPARAM(lParam);
			int Left,Right;
			int i;

			Left=0;
			for (i=0;i<NUM_STATUS_ITEMS;i++) {
				Right=Left+STATUS_MARGIN*2+pStatus->m_pItemList[i]->Width();
				if (x>=Left && x<Right)
					break;
				Left=Right;
			}
			if (i==NUM_STATUS_ITEMS)
				i=-1;
			if (i!=pStatus->m_HotItem) {
				int OldHotItem;

				OldHotItem=pStatus->m_HotItem;
				pStatus->m_HotItem=i;
				if (OldHotItem>=0)
					pStatus->UpdateItem(OldHotItem);
				if (pStatus->m_HotItem>=0)
					pStatus->UpdateItem(pStatus->m_HotItem);
			}
			if (!pStatus->m_fTrackMouseEvent) {
				TRACKMOUSEEVENT tme;

				tme.cbSize=sizeof(TRACKMOUSEEVENT);
				tme.dwFlags=TME_LEAVE;
				tme.hwndTrack=hwnd;
				if (TrackMouseEvent(&tme))
					pStatus->m_fTrackMouseEvent=true;
			}
		}
		return 0;

	case WM_MOUSELEAVE:
		{
			CStatusView *pStatus=GetStatusView(hwnd);

			if (pStatus->m_HotItem>=0) {
				int i=pStatus->m_HotItem;

				pStatus->m_HotItem=-1;
				pStatus->UpdateItem(i);
			}
			pStatus->m_fTrackMouseEvent=false;
		}
		return 0;

	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:
		{
			CStatusView *pStatus=GetStatusView(hwnd);

			if (pStatus->m_HotItem>=0) {
				int x=GET_X_LPARAM(lParam),y=GET_Y_LPARAM(lParam);
				RECT rc;

				pStatus->GetItemRect(pStatus->m_HotItem,&rc);
				x-=rc.left;
				if (uMsg==WM_LBUTTONDOWN)
					pStatus->m_pItemList[pStatus->m_HotItem]->OnLButtonDown(x,y);
				else
					pStatus->m_pItemList[pStatus->m_HotItem]->OnRButtonDown(x,y);
			}
		}
		return 0;

	case WM_LBUTTONUP:
		if (GetCapture()==hwnd) {
			ReleaseCapture();
		}
		return 0;

	case WM_SETCURSOR:
		if (LOWORD(lParam)==HTCLIENT) {
			CStatusView *pStatus=GetStatusView(hwnd);

			if (pStatus->m_HotItem>=0) {
				SetCursor(LoadCursor(NULL,IDC_HAND));
				return TRUE;
			}
		}
		break;

	case WM_DESTROY:
		{
			CStatusView *pStatus=GetStatusView(hwnd);

			DeleteObject(pStatus->m_hfontStatus);
			pStatus->m_hwnd=NULL;
		}
		return 0;
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


void CStatusView::UpdateItem(int Index)
{
	RECT rc;

	GetItemRect(Index,&rc);
	InvalidateRect(m_hwnd,&rc,TRUE);
}


bool CStatusView::GetItemRect(int Index,RECT *pRect) const
{
	int i;
	RECT rc;

	GetClientRect(m_hwnd,&rc);
	for (i=0;i<Index;i++)
		rc.left+=m_pItemList[i]->Width()+STATUS_MARGIN*2;
	rc.right=rc.left+m_pItemList[i]->Width()+STATUS_MARGIN*2;
	*pRect=rc;
	return true;
}


void CStatusView::GetRect(RECT *pRect) const
{
	GetWindowRect(m_hwnd,pRect);
}


int CStatusView::Height() const
{
	RECT rc;

	GetWindowRect(m_hwnd,&rc);
	return rc.bottom-rc.top;
}


void CStatusView::Move(int x,int y,int Width,int Height)
{
	MoveWindow(m_hwnd,x,y,Width,Height,TRUE);
}


void CStatusView::SetSingleText(LPCTSTR pszText)
{
	delete [] m_pszSingleText;
	if (pszText!=NULL) {
		m_pszSingleText=new TCHAR[lstrlen(pszText)+1];
		lstrcpy(m_pszSingleText,pszText);
		m_fSingleMode=true;
	} else {
		m_pszSingleText=NULL;
		m_fSingleMode=false;
	}
	InvalidateRect(m_hwnd,NULL,TRUE);
}


void CStatusView::SetColor(COLORREF crBack,COLORREF crText)
{
	m_crBackColor=crBack;
	m_crTextColor=crText;
	InvalidateRect(m_hwnd,NULL,TRUE);
}


static CStatusView Status;




static HMENU GetTopMenu(int Pos)
{
	return GetSubMenu(GetSubMenu(hmenuMain,0),Pos);
}


static void ClearMenu(HMENU hmenu)
{
	int Count,i;

	Count=GetMenuItemCount(hmenu);
	for (i=Count-1;i>=0;i--)
		DeleteMenu(hmenu,i,MF_BYPOSITION);
}


static void SetChannelMenu(HMENU hmenu)
{
	int i;
	TCHAR szText[MAX_CHANNEL_NAME+4];

	ClearMenu(hmenu);
	for (i=0;i<ChannelList.NumChannels();i++) {
		wsprintf(szText,TEXT("%d: %s"),ChannelList.GetChannelNo(i),
													ChannelList.GetName(i));
		AppendMenu(hmenu,MFT_STRING | MFS_ENABLED
				| (i!=0 && i%12==0?MF_MENUBREAK:0),CM_CHANNEL_FIRST+i,szText);
	}
	if (CurrentChannel>=0)
		CheckMenuRadioItem(hmenuMain,CM_CHANNEL_FIRST,
								CM_CHANNEL_FIRST+ChannelList.NumChannels()-1,
								CM_CHANNEL_FIRST+CurrentChannel,MF_BYCOMMAND);
}


static void SetNetworkRemoconChannelMenu(HMENU hmenu)
{
	const CChannelList &RemoconChList=pNetworkRemocon->GetChannelList();
	int i;
	TCHAR szText[MAX_CHANNEL_NAME+4];

	ClearMenu(hmenu);
	if (RemoconChList.NumChannels()>0) {
		int No,Min,Max;

		Min=1000;
		Max=0;
		for (i=0;i<RemoconChList.NumChannels();i++) {
			No=RemoconChList.GetChannelNo(i);
			if (No<Min)
				Min=No;
			if (No>Max)
				Max=No;
		}
		for (No=Min;No<=Max;No++) {
			for (i=0;i<RemoconChList.NumChannels();i++) {
				if (RemoconChList.GetChannelNo(i)==No) {
					wsprintf(szText,TEXT("%d: %s"),
												RemoconChList.GetChannelNo(i),
												RemoconChList.GetName(i));
					AppendMenu(hmenu,MFT_STRING | MFS_ENABLED,
						CM_CHANNELNO_FIRST+RemoconChList.GetChannelNo(i)-1,
																	szText);
				}
			}
		}
	}
	for (i=0;i<ChannelList.NumChannels();i++) {
		wsprintf(szText,TEXT("%d: %s"),ChannelList.GetChannelNo(i),
													ChannelList.GetName(i));
		AppendMenu(hmenu,MFT_STRING | MFS_ENABLED
			| ((i!=0 && i%12==0) || (i==0 && RemoconChList.NumChannels()>0)?
															MF_MENUBREAK:0),
												CM_CHANNEL_FIRST+i,szText);
	}
	if (CurrentChannel>=0)
		CheckMenuRadioItem(hmenuMain,CM_CHANNEL_FIRST,
								CM_CHANNEL_FIRST+ChannelList.NumChannels()-1,
								CM_CHANNEL_FIRST+CurrentChannel,MF_BYCOMMAND);
}


static void SetSpaceMenu(HMENU hmenu)
{
	int i;
	LPCTSTR pszName;

	ClearMenu(hmenu);
	NumSpaces=0;
	for (i=0;(pszName=DtvEngine.m_BonSrcDecoder.GetSpaceName(i))!=NULL;i++) {
		AppendMenu(hmenu,MFT_STRING | MFS_ENABLED,CM_SPACE_FIRST+i,pszName);
		NumSpaces++;
	}
	if (NumSpaces>0)
		CheckMenuRadioItem(hmenu,CM_SPACE_FIRST,CM_SPACE_FIRST+NumSpaces-1,
									CM_SPACE_FIRST+CurrentSpace,MF_BYCOMMAND);
}


static void CheckZoomMenu()
{
	int Zoom;
	int i;

	Zoom=CalcZoomRate();
	for (i=0;i<lengthof(ZoomList);i++) {
		CheckMenuItem(hmenuMain,CM_ZOOM_FIRST+i,
				MF_BYCOMMAND | (ZoomList[i]==Zoom?MFS_CHECKED:MFS_UNCHECKED));
	}
}




static bool InitNetworkRemocon()
{
	CChannelList List;
	TCHAR szChFilePath[MAX_PATH];

	LoadChannelList(&List,szChannelListFileName);
	List.SetChannelOffset(FIRST_CHANNEL);
	pNetworkRemocon=new CNetworkRemocon;
	GetNetworkRemoconChFilePath(szNetworkRemoconChFile,szChFilePath);
	if (pNetworkRemocon->LoadChannelText(szChFilePath,&List))
		SetNetworkRemoconChannelMenu(GetTopMenu(MENU_POS_CHANNEL));
	pNetworkRemocon->Init(szNetworkRemoconAddress,NetworkRemoconPort);
	return true;
}




class CKeyHook {
	HMODULE m_hLib;
	bool m_fHook;
	UINT m_Message;
public:
	CKeyHook();
	~CKeyHook();
	bool BeginHook();
	bool EndHook();
	bool TranslateMessage(UINT uMsg,WPARAM wParam,LPARAM lParam);
};

CKeyHook::CKeyHook()
{
	m_hLib=NULL;
	m_fHook=false;
	m_Message=WM_NULL;
}

CKeyHook::~CKeyHook()
{
	if (m_hLib!=NULL) {
		EndHook();
		FreeLibrary(m_hLib);
	}
}

bool CKeyHook::BeginHook()
{
	BeginHookFunc pBeginHook;

	if (m_hLib==NULL) {
		m_hLib=LoadLibrary(TEXT("HDUSTest_KeyHook.dll"));
		if (m_hLib==NULL)
			return false;
	}
	pBeginHook=(BeginHookFunc)GetProcAddress(m_hLib,"BeginHook");
	if (pBeginHook==NULL || !pBeginHook(hwndMain))
		return false;
	m_fHook=true;
	m_Message=RegisterWindowMessage(KEYHOOK_MESSAGE);

	// Vista ŊǗҌŎsꂽp̑΍
#ifndef MSGFLT_ADD
#define MSGFLT_ADD 1
#endif
	typedef BOOL (WINAPI *ChangeWindowMessageFilterFunc)(UINT,DWORD);
	HMODULE hLib=LoadLibrary(TEXT("user32.dll"));
	ChangeWindowMessageFilterFunc pChangeFilter=(ChangeWindowMessageFilterFunc)
							GetProcAddress(hLib,"ChangeWindowMessageFilter");

	if (pChangeFilter!=NULL)
		pChangeFilter(m_Message,MSGFLT_ADD);
	FreeLibrary(hLib);
	return true;
}

bool CKeyHook::EndHook()
{
	if (m_fHook) {
		EndHookFunc pEndHook;

		pEndHook=(EndHookFunc)GetProcAddress(m_hLib,"EndHook");
		if (pEndHook==NULL)
			return false;
		pEndHook();
		m_fHook=false;
	}
	return true;
}

bool CKeyHook::TranslateMessage(UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	static const struct {
		WORD Key;
		WORD Modifier;
		int Command;
	} KeyMap[] = {
		{VK_F17,	MK_SHIFT,	CM_CHANNELNO_1},
		{VK_F18,	MK_SHIFT,	CM_CHANNELNO_2},
		{VK_F19,	MK_SHIFT,	CM_CHANNELNO_3},
		{VK_F20,	MK_SHIFT,	CM_CHANNELNO_4},
		{VK_F21,	MK_SHIFT,	CM_CHANNELNO_5},
		{VK_F22,	MK_SHIFT,	CM_CHANNELNO_6},
		{VK_F23,	MK_SHIFT,	CM_CHANNELNO_7},
		{VK_F24,	MK_SHIFT,	CM_CHANNELNO_8},
		{VK_F13,	MK_CONTROL,	CM_CHANNELNO_9},
		{VK_F16,	MK_SHIFT,	CM_CHANNELNO_10},
		{VK_F14,	MK_CONTROL,	CM_CHANNELNO_11},
		{VK_F15,	MK_CONTROL,	CM_CHANNELNO_12},
		{VK_F15,	MK_SHIFT,	CM_VOLUME_MUTE},
		{VK_F13,	MK_SHIFT,	CM_ASPECTRATIO},
		{VK_F14,	MK_SHIFT,	CM_EXIT},
		{VK_F16,	MK_CONTROL,	CM_MENU},
		{VK_F17,	MK_CONTROL,	CM_FULLSCREEN},
		{VK_F19,	MK_CONTROL,	CM_STEREOMODE},
		{VK_F22,	MK_CONTROL,	CM_RECORD_START},
		{VK_F24,	MK_CONTROL,	CM_RECORD_STOP},
		/*
		{VK_UP,		MK_SHIFT,	CM_VOLUME_UP},
		{VK_DOWN,	MK_SHIFT,	CM_VOLUME_DOWN},
		{VK_UP,		MK_CONTROL,	CM_CHANNEL_UP},
		{VK_DOWN,	MK_CONTROL,	CM_CHANNEL_DOWN},
		*/
	};
	int i;

	if (m_Message==WM_NULL || uMsg!=m_Message)
		return false;
	for (i=0;i<lengthof(KeyMap);i++) {
		if (KeyMap[i].Key==wParam && KeyMap[i].Modifier==lParam) {
			SendMessage(hwndMain,WM_COMMAND,KeyMap[i].Command,0);
			break;
		}
	}
	return true;
}


class CKeyHook *pKeyHook=NULL;




static void EnableDlgItem(HWND hDlg,int ID,BOOL fEnable)
{
	EnableWindow(GetDlgItem(hDlg,ID),fEnable);
}


static bool ChooseColorDialog(HWND hwndOwner,COLORREF *pcrResult)
{
	CHOOSECOLOR cc;
	static COLORREF crCustomColors[16] = {
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),RGB(0xFF,0xFF,0xFF),
		RGB(0xFF,0xFF,0xFF)
	};

	cc.lStructSize=sizeof(CHOOSECOLOR);
	cc.hwndOwner=hwndOwner;
	cc.hInstance=NULL;
	cc.rgbResult=*pcrResult;
	cc.lpCustColors=crCustomColors;
	cc.Flags=CC_RGBINIT | CC_FULLOPEN;
	if (!ChooseColor(&cc))
		return false;
	*pcrResult=cc.rgbResult;
	return true;
}


static BOOL CALLBACK GeneralOptionsDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,
																LPARAM lParam)
{
	static COLORREF crStatusBack,crStatusText;

	switch (uMsg) {
	case WM_INITDIALOG:
		SetDlgItemText(hDlg,IDC_OPTIONS_DRIVER,szDriverFileName);
		CheckDlgButton(hDlg,IDC_OPTIONS_NODESCRAMBLE,
									fNoDescramble?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_USEREMOTECONTROLLER,
								fNoRemoteController?BST_UNCHECKED:BST_CHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_REMOTECONTROLLERACTIVEONLY,
										fNoKeyHook?BST_CHECKED:BST_UNCHECKED);
		EnableDlgItem(hDlg,IDC_OPTIONS_REMOTECONTROLLERACTIVEONLY,
														!fNoRemoteController);
		CheckDlgButton(hDlg,IDC_OPTIONS_NOSCREENSAVER,
									fNoScreenSaver?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_NOMONITORLOWPOWER,
								fNoMonitorLowPower?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_NOMONITORLOWPOWERACTIVEONLY,
					fNoMonitorLowPowerActiveOnly?BST_CHECKED:BST_UNCHECKED);
		EnableDlgItem(hDlg,IDC_OPTIONS_NOMONITORLOWPOWERACTIVEONLY,
														fNoMonitorLowPower);
		CheckDlgButton(hDlg,IDC_OPTIONS_RESTORECHANNEL,
									fRestoreChannel?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_ADJUSTASPECTRESIZING,
							fAdjustAspectResizing?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hDlg,IDC_OPTIONS_CONFIRMRECCHANNELCHANGE,
						fConfirmRecChannelChange?BST_CHECKED:BST_UNCHECKED);
		crStatusBack=crStatusBkColor;
		crStatusText=crStatusTextColor;
		return TRUE;

	case WM_DRAWITEM:
		{
			LPDRAWITEMSTRUCT pdis=(LPDRAWITEMSTRUCT)lParam;
			HBRUSH hbr;

			hbr=CreateSolidBrush(pdis->CtlID==IDC_OPTIONS_STATUSBACKCOLOR?
													crStatusBack:crStatusText);
			FillRect(pdis->hDC,&pdis->rcItem,hbr);
			DeleteObject(hbr);
		}
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_OPTIONS_USEREMOTECONTROLLER:
			EnableDlgItem(hDlg,IDC_OPTIONS_REMOTECONTROLLERACTIVEONLY,
					IsDlgButtonChecked(hDlg,IDC_OPTIONS_USEREMOTECONTROLLER));
			return TRUE;

		case IDC_OPTIONS_NOMONITORLOWPOWER:
			EnableDlgItem(hDlg,IDC_OPTIONS_NOMONITORLOWPOWERACTIVEONLY,
					IsDlgButtonChecked(hDlg,IDC_OPTIONS_NOMONITORLOWPOWER));
			return TRUE;

		case IDC_OPTIONS_STATUSBACKCOLOR:
			if (ChooseColorDialog(hDlg,&crStatusBack))
				InvalidateRect(GetDlgItem(hDlg,IDC_OPTIONS_STATUSBACKCOLOR),
																	NULL,TRUE);
			return TRUE;

		case IDC_OPTIONS_STATUSTEXTCOLOR:
			if (ChooseColorDialog(hDlg,&crStatusText))
				InvalidateRect(GetDlgItem(hDlg,IDC_OPTIONS_STATUSTEXTCOLOR),
																	NULL,TRUE);
			return TRUE;
		}
		return TRUE;

	case WM_NOTIFY:
		switch (((LPNMHDR)lParam)->code) {
		case PSN_APPLY:
			{
				bool f1,f2;

				GetDlgItemText(hDlg,IDC_OPTIONS_DRIVER,szDriverFileName,
												lengthof(szDriverFileName));
				fNoDescramble=IsDlgButtonChecked(hDlg,IDC_OPTIONS_NODESCRAMBLE)
																==BST_CHECKED;
				f1=IsDlgButtonChecked(hDlg,
							IDC_OPTIONS_USEREMOTECONTROLLER)==BST_UNCHECKED;
				f2=IsDlgButtonChecked(hDlg,
						IDC_OPTIONS_REMOTECONTROLLERACTIVEONLY)==BST_CHECKED;
				if (f1!=fNoRemoteController || f2!=fNoKeyHook) {
					if (f1 || f2) {
						if (pKeyHook!=NULL) {
							delete pKeyHook;
							pKeyHook=NULL;
						}
					} else {
						if (pKeyHook==NULL) {
							pKeyHook=new CKeyHook;
							pKeyHook->BeginHook();
						}
					}
					if (f1) {
						hAccel=NULL;
					} else {
						hAccel=LoadAccelerators(hInst,
									MAKEINTRESOURCE(f2?IDA_ACCEL:IDA_ACCEL2));
					}
					fNoRemoteController=f1;
					fNoKeyHook=f2;
				}
				fNoScreenSaver=IsDlgButtonChecked(hDlg,
									IDC_OPTIONS_NOSCREENSAVER)==BST_CHECKED;
				fNoMonitorLowPower=IsDlgButtonChecked(hDlg,
								IDC_OPTIONS_NOMONITORLOWPOWER)==BST_CHECKED;
				fNoMonitorLowPowerActiveOnly=IsDlgButtonChecked(hDlg,
						IDC_OPTIONS_NOMONITORLOWPOWERACTIVEONLY)==BST_CHECKED;
				SetDisplayStatus();
				fRestoreChannel=IsDlgButtonChecked(hDlg,
									IDC_OPTIONS_RESTORECHANNEL)==BST_CHECKED;
				fAdjustAspectResizing=IsDlgButtonChecked(hDlg,
								IDC_OPTIONS_ADJUSTASPECTRESIZING)==BST_CHECKED;
				fConfirmRecChannelChange=IsDlgButtonChecked(hDlg,
							IDC_OPTIONS_CONFIRMRECCHANNELCHANGE)==BST_CHECKED;
				crStatusBkColor=crStatusBack;
				crStatusTextColor=crStatusText;
				Status.SetColor(crStatusBkColor,crStatusTextColor);
			}
			return TRUE;
		}
		break;
	}
	return FALSE;
}


static BOOL CALLBACK NetworkRemoconOptionsDlgProc(HWND hDlg,UINT uMsg,
												WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		CheckDlgButton(hDlg,IDC_NETWORKREMOCON_USE,
								fUseNetworkRemocon?BST_CHECKED:BST_UNCHECKED);
		SetDlgItemTextA(hDlg,IDC_NETWORKREMOCON_ADDRESS,szNetworkRemoconAddress);
		SetDlgItemInt(hDlg,IDC_NETWORKREMOCON_PORT,NetworkRemoconPort,FALSE);
		SetDlgItemText(hDlg,IDC_NETWORKREMOCON_CHANNELFILE,
													szNetworkRemoconChFile);
		return TRUE;

	case WM_NOTIFY:
		switch (((LPNMHDR)lParam)->code) {
		case PSN_APPLY:
			{
				bool fUse;
				char szAddress[16];
				unsigned int Port;
				TCHAR szChannelFile[MAX_PATH];

				fUse=IsDlgButtonChecked(hDlg,IDC_NETWORKREMOCON_USE)==
																BST_CHECKED;
				GetDlgItemTextA(hDlg,IDC_NETWORKREMOCON_ADDRESS,szAddress,
														lengthof(szAddress));
				Port=GetDlgItemInt(hDlg,IDC_NETWORKREMOCON_PORT,NULL,FALSE);
				GetDlgItemText(hDlg,IDC_NETWORKREMOCON_CHANNELFILE,
										szChannelFile,lengthof(szChannelFile));
				if (fUse!=fUseNetworkRemocon) {
					fUseNetworkRemocon=fUse;
					if (fUse) {
						if (fUDPDriver) {
							NetworkRemoconPort=Port;
							lstrcpyA(szNetworkRemoconAddress,szAddress);
							lstrcpy(szNetworkRemoconChFile,szChannelFile);
							InitNetworkRemocon();
						}
					} else if (pNetworkRemocon!=NULL) {
						delete pNetworkRemocon;
						pNetworkRemocon=NULL;
						SetChannelMenu(GetTopMenu(MENU_POS_CHANNEL));
					}
				} else {
					if (fUseNetworkRemocon
							&& (NetworkRemoconPort!=Port
								|| lstrcmpiA(szNetworkRemoconAddress,szAddress)!=0)) {
						pNetworkRemocon->Init(szAddress,Port);
					}
					if (lstrcmpi(szNetworkRemoconChFile,szChannelFile)!=0) {
						CChannelList List;
						TCHAR szChannelFilePath[MAX_PATH];

						LoadChannelList(&List,szChannelListFileName);
						List.SetChannelOffset(FIRST_CHANNEL);
						GetNetworkRemoconChFilePath(szChannelFile,
															szChannelFilePath);
						pNetworkRemocon=new CNetworkRemocon;
						pNetworkRemocon->LoadChannelText(szChannelFile,&List);
						SetNetworkRemoconChannelMenu(
												GetTopMenu(MENU_POS_CHANNEL));
					}
				}
				NetworkRemoconPort=Port;
				lstrcpyA(szNetworkRemoconAddress,szAddress);
				lstrcpy(szNetworkRemoconChFile,szChannelFile);
			}
			return TRUE;
		}
		break;
	}
	return FALSE;
}


static bool OptionsDialog(HWND hwndOwner)
{
	PROPSHEETPAGE psp[2];
	PROPSHEETHEADER psh;
	int i;

	for (i=0;i<lengthof(psp);i++) {
		psp[i].dwSize=sizeof(PROPSHEETPAGE);
		psp[i].dwFlags=PSP_DEFAULT;
		psp[i].hInstance=hInst;
	}
	psp[0].pszTemplate=MAKEINTRESOURCE(IDD_OPTIONS_GENERAL);
	psp[0].pfnDlgProc=GeneralOptionsDlgProc;
	psp[1].pszTemplate=MAKEINTRESOURCE(IDD_OPTIONS_NETWORKREMOCON);
	psp[1].pfnDlgProc=NetworkRemoconOptionsDlgProc;
	// vpeBV[g̐ݒ
	psh.dwSize=sizeof(PROPSHEETHEADER);
	psh.dwFlags=PSH_NOAPPLYNOW | PSH_PROPSHEETPAGE | PSH_NOCONTEXTHELP;
	psh.hwndParent=hwndOwner;
	psh.hInstance=hInst;
	psh.pszCaption=TEXT("ݒ");
	psh.nPages=lengthof(psp);
	psh.nStartPage=0;
	psh.ppsp=psp;
	PropertySheet(&psh);
	return true;
}




LRESULT CALLBACK ViewWndProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_SIZE:
		if (GetParent(hwndVideoContainer)==hwnd)
			MoveWindow(hwndVideoContainer,0,0,LOWORD(lParam),HIWORD(lParam),
																		TRUE);
		return 0;

	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:
	case WM_LBUTTONDBLCLK:
		{
			POINT pt;

			pt.x=GET_X_LPARAM(lParam);
			pt.y=GET_Y_LPARAM(lParam);
			MapWindowPoints(hwnd,GetParent(hwnd),&pt,1);
			return SendMessage(GetParent(hwnd),uMsg,wParam,
														MAKELPARAM(pt.x,pt.y));
		}

	case WM_SETCURSOR:
		if (LOWORD(lParam)==HTCLIENT) {
			SetCursor(LoadCursor(NULL,IDC_ARROW));
			return TRUE;
		}
		break;
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


LRESULT CALLBACK VideoContainerWndProc(HWND hwnd,UINT uMsg,WPARAM wParam,
																LPARAM lParam)
{
	switch (uMsg) {
	case WM_SIZE:
		DtvEngine.SetViewSize(LOWORD(lParam),HIWORD(lParam));
		return 0;

	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:
	case WM_LBUTTONDBLCLK:
	case WM_MOUSEMOVE:
		{
			POINT pt;

			pt.x=GET_X_LPARAM(lParam);
			pt.y=GET_Y_LPARAM(lParam);
			MapWindowPoints(hwnd,GetParent(hwnd),&pt,1);
			return SendMessage(GetParent(hwnd),uMsg,wParam,
														MAKELPARAM(pt.x,pt.y));
		}
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


static void PopupMenu(int x,int y)
{
	static BOOL fPopup=FALSE;

	if (!fPopup) {
		fPopup=TRUE;
		TrackPopupMenu(GetSubMenu(hmenuMain,0),TPM_RIGHTBUTTON,x,y,0,hwndMain,
																		NULL);
		fPopup=FALSE;
	} else
		EndMenu();
}


class CFullscreen {
	HWND m_hwnd;
	bool m_fShowCursor;
	bool m_fMenu;
	static CFullscreen *GetThis(HWND hwnd);
	static LRESULT CALLBACK WndProc(HWND hwnd,UINT uMsg,
												WPARAM wParam,LPARAM lParam);
public:
	CFullscreen();
	~CFullscreen();
	bool Create(HWND hwndOwner);
	void OnRButtonDown();
	void OnMouseMove();
	HWND GetHandle() const { return m_hwnd; }
	static bool Init();
};


bool CFullscreen::Init()
{
	WNDCLASS wc;

	wc.style=0;
	wc.lpfnWndProc=WndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hInstance=hInst;
	wc.hIcon=NULL;
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=CreateSolidBrush(RGB(0,0,0));
	wc.lpszMenuName=NULL;
	wc.lpszClassName=FULLSCREEN_WINDOW_CLASS;
	return RegisterClass(&wc)!=0;
}


CFullscreen *CFullscreen::GetThis(HWND hwnd)
{
	return (CFullscreen*)GetWindowLongPtr(hwnd,GWLP_USERDATA);
}


LRESULT CALLBACK CFullscreen::WndProc(HWND hwnd,UINT uMsg,WPARAM wParam,
																LPARAM lParam)
{
	switch (uMsg) {
	case WM_CREATE:
		{
			CFullscreen *pFullscreen=
						(CFullscreen*)((LPCREATESTRUCT)lParam)->lpCreateParams;

			SetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR)pFullscreen);
			SetParent(hwndVideoContainer,hwnd);
			pFullscreen->m_fShowCursor=true;
			pFullscreen->m_fMenu=false;
			SetTimer(hwnd,1,1000,NULL);
		}
		return 0;

	case WM_SIZE:
		MoveWindow(hwndVideoContainer,0,0,LOWORD(lParam),HIWORD(lParam),TRUE);
		return 0;

	case WM_RBUTTONDOWN:
		{
			CFullscreen *pFullscreen=GetThis(hwnd);

			pFullscreen->OnRButtonDown();
		}
		return 0;

	case WM_LBUTTONDBLCLK:
		SendMessage(hwndMain,WM_COMMAND,CM_FULLSCREEN,0);
		return 0;

	case WM_MOUSEMOVE:
		{
			CFullscreen *pFullscreen=GetThis(hwnd);

			pFullscreen->OnMouseMove();
		}
		return 0;

	case WM_TIMER:
		{
			CFullscreen *pFullscreen=GetThis(hwnd);

			if (!pFullscreen->m_fMenu) {
				SetCursor(NULL);
				DtvEngine.m_MediaViewer.HideCursor(true);
				pFullscreen->m_fShowCursor=false;
			}
			KillTimer(hwnd,1);
		}
		return 0;

	case WM_SETCURSOR:
		if (LOWORD(lParam)==HTCLIENT) {
			CFullscreen *pFullscreen=GetThis(hwnd);

			SetCursor(pFullscreen->m_fShowCursor?
											LoadCursor(NULL,IDC_ARROW):NULL);
			return TRUE;
		}
		break;

	case WM_KEYDOWN:
		if (wParam==VK_ESCAPE) {
			SendMessage(hwndMain,WM_COMMAND,CM_FULLSCREEN,0);
			return 0;
		}
		return SendMessage(hwndMain,uMsg,wParam,lParam);

	case WM_SYSCOMMAND:
		switch (wParam) {
		case SC_MONITORPOWER:
			if (fNoMonitorLowPower)
				return TRUE;
			break;
		}
		break;

	case WM_CLOSE:
		{
			RECT rc;

			GetClientRect(hwndView,&rc);
			SetParent(hwndVideoContainer,hwndView);
			SendMessage(hwndView,WM_SIZE,0,MAKELPARAM(rc.right,rc.bottom));
		}
		break;

	case WM_DESTROY:
		{
			CFullscreen *pFullscreen=GetThis(hwnd);

			//if (!m_fShowCursor)
				DtvEngine.m_MediaViewer.HideCursor(false);
			pFullscreen->m_hwnd=NULL;
		}
		return 0;
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


CFullscreen::CFullscreen()
{
	m_hwnd=NULL;
}


bool CFullscreen::Create(HWND hwndOwner)
{
	HMONITOR hMonitor;
	MONITORINFO mi;
	int x,y,Width,Height;

	hMonitor=MonitorFromWindow(hwndMain,MONITOR_DEFAULTTONEAREST);
	if (hMonitor!=NULL) {
		MONITORINFO mi;

		mi.cbSize=sizeof(MONITORINFO);
		GetMonitorInfo(hMonitor,&mi);
		x=mi.rcMonitor.left;
		y=mi.rcMonitor.top;
		Width=mi.rcMonitor.right-mi.rcMonitor.left;
		Height=mi.rcMonitor.bottom-mi.rcMonitor.top;
	} else {
		x=y=0;
		Width=GetSystemMetrics(SM_CXSCREEN);
		Height=GetSystemMetrics(SM_CYSCREEN);
	}
	m_hwnd=CreateWindowEx(/*WS_EX_TOPMOST*/0,FULLSCREEN_WINDOW_CLASS,NULL,
		WS_POPUP | WS_VISIBLE | WS_CLIPCHILDREN,x,y,Width,Height,hwndOwner,
		NULL,hInst,this);
	return m_hwnd!=NULL;
}


CFullscreen::~CFullscreen()
{
	if (m_hwnd!=NULL)
		SendMessage(m_hwnd,WM_CLOSE,0,0);
}


void CFullscreen::OnRButtonDown()
{
	POINT pt;

	GetCursorPos(&pt);
	// j[\̓J[\Ȃ
	KillTimer(m_hwnd,1);
	m_fShowCursor=true;
	DtvEngine.m_MediaViewer.HideCursor(false);
	SetCursor(LoadCursor(NULL,IDC_ARROW));
	m_fMenu=true;
	PopupMenu(pt.x,pt.y);
	m_fMenu=false;
	SetTimer(m_hwnd,1,1000,NULL);
}


void CFullscreen::OnMouseMove()
{
	if (m_fMenu)
		return;
	if (!m_fShowCursor) {
		SetCursor(LoadCursor(NULL,IDC_ARROW));
		DtvEngine.m_MediaViewer.HideCursor(false);
		m_fShowCursor=true;
	}
	SetTimer(m_hwnd,1,1000,NULL);
}


static CFullscreen *pFullscreen=NULL;




BOOL CALLBACK AboutDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		{
			HBITMAP hbm;
			RECT rc;

			hbm=LoadBitmap(hInst,MAKEINTRESOURCE(IDB_LOGO));
			SendDlgItemMessage(hDlg,IDC_ABOUT_LOGO,STM_SETIMAGE,IMAGE_BITMAP,
																(LPARAM)hbm);
			GetWindowRect(hDlg,&rc);
			MoveWindow(hDlg,
						(GetSystemMetrics(SM_CXSCREEN)-(rc.right-rc.left))/2,
						(GetSystemMetrics(SM_CYSCREEN)-(rc.bottom-rc.top))/2,
						rc.right-rc.left,rc.bottom-rc.top,FALSE);
		}
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
		case IDCANCEL:
			EndDialog(hDlg,LOWORD(wParam));
			return TRUE;
		}
		break;

	case WM_DESTROY:
		{
			HBITMAP hbm=(HBITMAP)SendDlgItemMessage(hDlg,IDC_ABOUT_LOGO,
							STM_SETIMAGE,IMAGE_BITMAP,(LPARAM)(HBITMAP)NULL);

			if (hbm!=NULL)
				DeleteObject(hbm);
		}
		return TRUE;
	}
	return FALSE;
}


static void AdjustWindowSize(int Width,int Height)
{
	RECT rc;

	GetWindowRect(hwndView,&rc);
	rc.right=rc.left+Width+GetSystemMetrics(SM_CXEDGE)*2;
	rc.bottom=rc.top+Height+GetSystemMetrics(SM_CYEDGE)*2;
	rc.bottom+=Status.Height();
	AdjustWindowRectEx(&rc,GetWindowStyle(hwndMain),FALSE,
												GetWindowExStyle(hwndMain));
	MoveWindow(hwndMain,rc.left,rc.top,rc.right-rc.left,rc.bottom-rc.top,TRUE);
}


static void SetForeground(HWND hwnd)
{
	int TargetID,ForegroundID;

	ForegroundID=GetWindowThreadProcessId(GetForegroundWindow(),NULL);
	TargetID=GetWindowThreadProcessId(hwnd,NULL);
	AttachThreadInput(TargetID,ForegroundID,TRUE);
	SetForegroundWindow(hwnd);
	AttachThreadInput(TargetID,ForegroundID,FALSE);
}


static bool RecChannelChangeDialog(HWND hwndOwner)
{
	return MessageBox(hwndOwner,TEXT("^撆łB`lύX܂?"),
						TEXT("`lύX̊mF"),
						MB_OKCANCEL | MB_DEFBUTTON2 | MB_ICONQUESTION)==IDOK;
}


class MyDtvEngineHandler : public CDtvEngineHandler
{
	const DWORD OnDtvEngineEvent(CDtvEngine *pEngine,const DWORD dwEventID,
																PVOID pParam);
};

const DWORD MyDtvEngineHandler::OnDtvEngineEvent(CDtvEngine *pEngine,
											const DWORD dwEventID,PVOID pParam)
{
	CProgManager *pProgManager=static_cast<CProgManager*>(pParam);
	int NumServices,i;
	TCHAR szServiceName[1024];
	LPTSTR *ppszList;

	NumServices=pProgManager->GetServiceNum();
	ppszList=new LPTSTR[NumServices];
	for (i=0;i<NumServices;i++) {
		if (!pProgManager->GetServiceName(szServiceName,i))
			lstrcpy(szServiceName,TEXT("T[rX擾..."));
		ppszList[i]=new TCHAR[lstrlen(szServiceName)+1];
		lstrcpy(ppszList[i],szServiceName);
	}
	PostMessage(hwndMain,WM_APP,MAKEWPARAM(pEngine->GetService(),NumServices),
															(LPARAM)ppszList);
	return 0;
}


static MyDtvEngineHandler DtvEngineHandler;


class CMyGetChannelReciver : public CNetworkRemoconReciver {
public:
	void OnRecive(LPCSTR pszText);
};

void CMyGetChannelReciver::OnRecive(LPCSTR pszText)
{
	int Channel;
	LPCSTR p;

	Channel=0;
	for (p=pszText;*p!='\0';p++)
		Channel=Channel*10+(*p-'0');
	PostMessage(hwndMain,WM_APP+1,Channel,0);
}


static CMyGetChannelReciver GetChannelReciver;


LRESULT CALLBACK MainWndProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_CREATE:
		{
			hwndView=CreateWindowEx(WS_EX_CLIENTEDGE,VIEW_WINDOW_CLASS,NULL,
									WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN,
									0,0,0,0,hwnd,(HMENU)IDC_VIEW,hInst,NULL);
			hwndVideoContainer=CreateWindowEx(0,VIDEO_CONTAINER_WINDOW_CLASS,
						NULL,WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN,
						0,0,0,0,hwndView,(HMENU)IDC_VIDEOCONTAINER,hInst,NULL);
			Status.Create(hwnd,IDC_STATUS,WS_CHILD | WS_VISIBLE,
															WS_EX_CLIENTEDGE);
			Status.SetColor(crStatusBkColor,crStatusTextColor);
			Status.SetSingleText(TEXT("N..."));
			hmenuMain=LoadMenu(hInst,MAKEINTRESOURCE(IDM_MENU));
			CheckMenuRadioItem(hmenuMain,CM_ASPECTRATIO_FIRST,
														CM_ASPECTRATIO_LAST,
							CM_ASPECTRATIO_FIRST+AspectRatioType,MF_BYCOMMAND);
			CheckMenuItem(hmenuMain,CM_FULLSCREEN,
					MF_BYCOMMAND | (fFullscreen?MFS_CHECKED:MFS_UNCHECKED));
			CheckMenuItem(hmenuMain,CM_ALWAYSONTOP,
					MF_BYCOMMAND | (fAlwaysOnTop?MFS_CHECKED:MFS_UNCHECKED));
			CheckMenuRadioItem(hmenuMain,CM_STEREO_THROUGH,CM_STEREO_RIGHT,
							CM_STEREO_THROUGH+CurrentStereoMode,MF_BYCOMMAND);
			CheckMenuItem(hmenuMain,CM_ADDRECORDTIME,
					MF_BYCOMMAND | (fAddRecordTime?MFS_CHECKED:MFS_UNCHECKED));

			HMENU hSysMenu;
			hSysMenu=GetSystemMenu(hwnd,FALSE);
			AppendMenu(hSysMenu,MFT_SEPARATOR,0,NULL);
			AppendMenu(hSysMenu,MFT_STRING | MFS_ENABLED,SC_ABOUT,
												TEXT("o[W(&A)..."));
		}
		return 0;

	case WM_SIZE:
		{
			int Height;

			Height=HIWORD(lParam)-Status.Height();
			MoveWindow(hwndView,0,0,LOWORD(lParam),Height,TRUE);
			Status.Move(0,Height,LOWORD(lParam),Status.Height());
			Status.UpdateItem(STATUS_ITEM_VIDEOSIZE);
			CheckZoomMenu();
		}
		return 0;

	case WM_SIZING:
		if (GetKeyState(VK_SHIFT)<0?!fAdjustAspectResizing:
													fAdjustAspectResizing) {
			BYTE XAspect,YAspect;

			if (DtvEngine.m_MediaViewer.GetEffectiveAspectRatio(
														&XAspect,&YAspect)) {
				LPRECT prc=(LPRECT)lParam;
				RECT rcWindow,rcClient;
				int XMargin,YMargin,Width,Height;

				GetWindowRect(hwnd,&rcWindow);
				GetClientRect(hwnd,&rcClient);
				rcClient.right-=GetSystemMetrics(SM_CXEDGE)*2;
				rcClient.bottom-=GetSystemMetrics(SM_CYEDGE)*2+Status.Height();
				if (rcClient.right<=0 || rcClient.bottom<=0)
					break;
				XMargin=(rcWindow.right-rcWindow.left)-rcClient.right;
				YMargin=(rcWindow.bottom-rcWindow.top)-rcClient.bottom;
				Width=(prc->right-prc->left)-XMargin;
				Height=(prc->bottom-prc->top)-YMargin;
				if (Width<=0 || Height<=0)
					break;
				if (wParam==WMSZ_LEFT || wParam==WMSZ_RIGHT)
					Height=Width*YAspect/XAspect;
				else if (wParam==WMSZ_TOP || wParam==WMSZ_BOTTOM)
					Width=Height*XAspect/YAspect;
				else if (Width*YAspect<Height*XAspect)
					Width=Height*XAspect/YAspect;
				else if (Width*YAspect>Height*XAspect)
					Height=Width*YAspect/XAspect;
				if (wParam==WMSZ_LEFT || wParam==WMSZ_TOPLEFT
													|| wParam==WMSZ_BOTTOMLEFT)
					prc->left=prc->right-(Width+XMargin);
				else
					prc->right=prc->left+Width+XMargin;
				if (wParam==WMSZ_TOP || wParam==WMSZ_TOPLEFT
													|| wParam==WMSZ_TOPRIGHT)
					prc->top=prc->bottom-(Height+YMargin);
				else
					prc->bottom=prc->top+Height+YMargin;
				return TRUE;
			}
		}
		break;

	case WM_TIMER:
		if (wParam==TIMER_ID_UPDATE) {
			WORD Width,Height;
			DWORD ErrCount,ScrambleCount;
			int NumChannels;

			if (DtvEngine.GetVideoSize(&Width,&Height)) {
				if (Width!=VideoWidth || Height!=VideoHeight) {
					VideoWidth=Width;
					VideoHeight=Height;
					Status.UpdateItem(STATUS_ITEM_VIDEOSIZE);
				}
				if (DtvEngine.m_MediaViewer.GetPanAndScanVideoSize(
															&Width,&Height)) {
					if (Width!=PanAndScanVideoWidth
							|| Height!=PanAndScanVideoHeight) {
						PanAndScanVideoWidth=Width;
						PanAndScanVideoHeight=Height;
						Status.UpdateItem(STATUS_ITEM_VIDEOSIZE);
						CheckZoomMenu();
					}
				}
			}
			ErrCount=DtvEngine.m_TsPacketParser.GetErrorPacketCount();
			ScrambleCount=DtvEngine.m_TsDescrambler.GetScramblePacketCount();
			if (ErrCount!=ErrorPacketCount
					|| ScrambleCount!=ScramblePacketCount) {
				ErrorPacketCount=ErrCount;
				ScramblePacketCount=ScrambleCount;
				Status.UpdateItem(STATUS_ITEM_ERROR);
			}
			// ԈႢT1
			//NumChannels=DtvEngine.GetAudioChannelNum();
			NumChannels=DtvEngine.GetAudioCahnnelNum();
			if (NumChannels>0) {
				if (NumChannels!=CurrentNumAudioChannels) {
					CurrentNumAudioChannels=NumChannels;
					SendMessage(hwnd,WM_COMMAND,CM_STEREO_THROUGH,0);
					//Status.UpdateItem(STATUS_ITEM_AUDIOCHANNEL);
				}
			}
		} else if (wParam==TIMER_ID_DISPLAY) {
			SetThreadExecutionState(ES_DISPLAY_REQUIRED | ES_CONTINUOUS);
		}
		return 0;

	case WM_RBUTTONDOWN:
		if (fFullscreen) {
			pFullscreen->OnRButtonDown();
		} else {
			POINT pt;

			pt.x=GET_X_LPARAM(lParam);
			pt.y=GET_Y_LPARAM(lParam);
			ClientToScreen(hwnd,&pt);
			PopupMenu(pt.x,pt.y);
		}
		return 0;

	case WM_LBUTTONDOWN:
		/*
		ptDragStartPos.x=GET_X_LPARAM(lParam);
		ptDragStartPos.y=GET_Y_LPARAM(lParam);
		ClientToScreen(hwnd,&ptDragStartPos);
		*/
		GetCursorPos(&ptDragStartPos);
		GetWindowRect(hwnd,&rcDragStart);
		SetCapture(hwnd);
		return 0;

	case WM_LBUTTONUP:
		if (GetCapture()==hwnd)
			ReleaseCapture();
		return 0;

	case WM_MOUSEMOVE:
		if (fFullscreen) {
			pFullscreen->OnMouseMove();
			return 0;
		}
		if (GetCapture()==hwnd) {
			POINT pt;

			/*
			pt.x=GET_X_LPARAM(lParam);
			pt.y=GET_Y_LPARAM(lParam);
			ClientToScreen(hwnd,&pt);
			*/
			GetCursorPos(&pt);
			MoveWindow(hwnd,rcDragStart.left+(pt.x-ptDragStartPos.x),
							rcDragStart.top+(pt.y-ptDragStartPos.y),
							rcDragStart.right-rcDragStart.left,
							rcDragStart.bottom-rcDragStart.top,TRUE);
		}
		return 0;

	case WM_LBUTTONDBLCLK:
		SendMessage(hwnd,WM_COMMAND,CM_FULLSCREEN,0);
		return 0;

	case WM_KEYDOWN:
		{
			int Command;

			if (wParam>=VK_F1 && wParam<=VK_F12) {
				Command=CM_CHANNELNO_FIRST+(wParam-VK_F1);
			} else if (wParam>=VK_NUMPAD1 && wParam<=VK_NUMPAD9) {
				Command=CM_CHANNELNO_FIRST+(wParam-VK_NUMPAD1);
			} else if (wParam>='0' && wParam<='9') {
				if (wParam=='0')
					Command=CM_CHANNELNO_FIRST+9;
				else
					Command=CM_CHANNELNO_FIRST+(wParam-'1');
			} else if (wParam==VK_UP) {
				Command=CM_VOLUME_UP;
			} else if (wParam==VK_DOWN) {
				Command=CM_VOLUME_DOWN;
			} else if (wParam==VK_LEFT) {
				Command=CM_CHANNEL_DOWN;
			} else if (wParam==VK_RIGHT) {
				Command=CM_CHANNEL_UP;
			} else if (wParam=='R') {
				Command=CM_RECORD;
			} else if (wParam=='S') {
				Command=CM_STEREOMODE;
			} else if (wParam=='A') {
				Command=CM_ASPECTRATIO;
			} else
				break;
			SendMessage(hwnd,WM_COMMAND,Command,0);
		}
		return 0;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case CM_ZOOM_25:
		case CM_ZOOM_33:
		case CM_ZOOM_50:
		case CM_ZOOM_66:
		case CM_ZOOM_75:
		case CM_ZOOM_100:
		case CM_ZOOM_150:
		case CM_ZOOM_200:
			{
				WORD Width,Height;

				if (fFullscreen)
					SendMessage(hwnd,WM_COMMAND,CM_FULLSCREEN,0);
				if (DtvEngine.m_MediaViewer.GetPanAndScanVideoSize(
															&Width,&Height)) {
					int w,h;
					BYTE XAspect,YAspect;
					int Zoom=ZoomList[LOWORD(wParam)-CM_ZOOM_FIRST];

					PanAndScanVideoWidth=w=Width;
					PanAndScanVideoHeight=h=Height;
					if (DtvEngine.m_MediaViewer.GetEffectiveAspectRatio(
															&XAspect,&YAspect))
						AdjustAspect(&w,&h,XAspect,YAspect);
					AdjustWindowSize(w*Zoom/100,h*Zoom/100);
				}
			}
			return 0;

		case CM_ASPECTRATIO:
			SendMessage(hwnd,WM_COMMAND,CM_ASPECTRATIO_FIRST+
				(AspectRatioType+1)%
							(CM_ASPECTRATIO_LAST-CM_ASPECTRATIO_FIRST+1),0);
			return 0;

		case CM_ASPECTRATIO_DEFAULT:
		case CM_ASPECTRATIO_16x9:
		case CM_ASPECTRATIO_LETTERBOX:
		case CM_ASPECTRATIO_SUPERFRAME:
		case CM_ASPECTRATIO_SIDECUT:
		case CM_ASPECTRATIO_4x3:
			{
				static const struct {
					BYTE XAspect,YAspect;
					BYTE PanAndScan;
				} AspectRatioList[] = {
					{ 0,0,0},
					{16,9,0},
					{16,9,CMediaViewer::PANANDSCAN_VERT},
					{16,9,CMediaViewer::PANANDSCAN_HORZ |
												CMediaViewer::PANANDSCAN_VERT},
					{ 4,3,CMediaViewer::PANANDSCAN_HORZ},
					{ 4,3,0},
				};
				int i=LOWORD(wParam)-CM_ASPECTRATIO_FIRST;
				int Zoom=CalcZoomRate();

				DtvEngine.m_MediaViewer.ForceAspectRatio(
					AspectRatioList[i].XAspect,AspectRatioList[i].YAspect);
				DtvEngine.m_MediaViewer.SetPanAndScan(
												AspectRatioList[i].PanAndScan);
				DtvEngine.m_MediaViewer.ResizeVideoWindow();
				if (!fFullscreen) {
					WORD Width,Height;

					if (Zoom>0
							&& DtvEngine.m_MediaViewer.GetPanAndScanVideoSize(
															&Width,&Height)) {
						int w,h;
						BYTE XAspect,YAspect;

						PanAndScanVideoWidth=w=Width;
						PanAndScanVideoHeight=h=Height;
						if (DtvEngine.m_MediaViewer.GetEffectiveAspectRatio(
															&XAspect,&YAspect))
							AdjustAspect(&w,&h,XAspect,YAspect);
						AdjustWindowSize(w*Zoom/100,h*Zoom/100);
					} else  if (DtvEngine.m_MediaViewer.GetDestSize(
															&Width,&Height)) {
						AdjustWindowSize(Width,Height);
					}
				}
				AspectRatioType=i;
				CheckMenuRadioItem(hmenuMain,CM_ASPECTRATIO_FIRST,
														CM_ASPECTRATIO_LAST,
							CM_ASPECTRATIO_FIRST+AspectRatioType,MF_BYCOMMAND);
				CheckZoomMenu();
			}
			return 0;

		case CM_FULLSCREEN:
			if (!fFullscreen)
				SetForeground(hwnd);
			/*
			if (DtvEngine.SwitchFullscreen()) {
				fFullscreen=!fFullscreen;
				CheckMenuItem(hmenuMain,CM_FULLSCREEN,
					MF_BYCOMMAND | (fFullscreen?MFS_CHECKED:MFS_UNCHECKED));
			}
			*/
			if (fFullscreen) {
				delete pFullscreen;
				pFullscreen=NULL;
				fFullscreen=false;
			} else {
				pFullscreen=new CFullscreen;
				if (pFullscreen->Create(hwnd))
					fFullscreen=true;
			}
			CheckMenuItem(hmenuMain,CM_FULLSCREEN,
					MF_BYCOMMAND | (fFullscreen?MFS_CHECKED:MFS_UNCHECKED));
			return 0;

		case CM_ALWAYSONTOP:
			fAlwaysOnTop=!fAlwaysOnTop;
			SetWindowPos(hwnd,fAlwaysOnTop?HWND_TOPMOST:HWND_NOTOPMOST,
											0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
			CheckMenuItem(hmenuMain,CM_ALWAYSONTOP,
					MF_BYCOMMAND | (fAlwaysOnTop?MFS_CHECKED:MFS_UNCHECKED));
			return 0;

		case CM_VOLUME_UP:
		case CM_VOLUME_DOWN:
			{
				bool fRestore=false;
				int Volume;

				if (fMute) {
					fMute=false;
					CheckMenuItem(hmenuMain,CM_VOLUME_MUTE,
												MF_BYCOMMAND | MFS_UNCHECKED);
					fRestore=true;
				}
				if (LOWORD(wParam)==CM_VOLUME_UP) {
					Volume=CurrentVolume+5;
					if (Volume>MAX_VOLUME)
						Volume=MAX_VOLUME;
				} else {
					Volume=CurrentVolume-5;
					if (Volume<0)
						Volume=0;
				}
				if (Volume!=CurrentVolume || fRestore) {
					DtvEngine.SetVolume(LevelToDeciBel(Volume));
					CurrentVolume=Volume;
					Status.UpdateItem(STATUS_ITEM_VOLUME);
				}
			}
			return 0;

		case CM_VOLUME_MUTE:
			{
				int Volume;

				fMute=!fMute;
				DtvEngine.SetVolume(LevelToDeciBel(fMute?0:CurrentVolume));
				Status.UpdateItem(STATUS_ITEM_VOLUME);
				CheckMenuItem(hmenuMain,CM_VOLUME_MUTE,
							MF_BYCOMMAND | (fMute?MFS_CHECKED:MFS_UNCHECKED));
			}
			return 0;

		case CM_STEREO_THROUGH:
		case CM_STEREO_LEFT:
		case CM_STEREO_RIGHT:
		case CM_STEREOMODE:
			if (LOWORD(wParam)==CM_STEREOMODE)
				CurrentStereoMode=(CurrentStereoMode+1)%3;
			else
				CurrentStereoMode=LOWORD(wParam)-CM_STEREO_THROUGH;
			DtvEngine.SetStereoMode(CurrentStereoMode);
			CheckMenuRadioItem(hmenuMain,CM_STEREO_THROUGH,CM_STEREO_RIGHT,
							CM_STEREO_THROUGH+CurrentStereoMode,MF_BYCOMMAND);
			Status.UpdateItem(STATUS_ITEM_AUDIOCHANNEL);
			return 0;

		case CM_COPY:
			if (fUseVMR9) {
				BYTE *pDib;

				if (DtvEngine.m_MediaViewer.GetCurrentImage(&pDib)) {
					if (OpenClipboard(hwnd)) {
						BITMAPINFOHEADER *pbmih=(BITMAPINFOHEADER*)pDib;
						int Width,Height;
						BYTE XAspect,YAspect;
						SIZE_T Size;
						HGLOBAL hGlobal=NULL;

						Width=pbmih->biWidth;
						Height=abs(pbmih->biHeight);
						Size=sizeof(BITMAPINFOHEADER);
						if (pbmih->biBitCount<=8)
							Size+=(1<<pbmih->biBitCount)*sizeof(RGBQUAD);
						else if (pbmih->biCompression==BI_BITFIELDS)
							Size+=3*sizeof(DWORD);
						if (DtvEngine.m_MediaViewer.GetEffectiveAspectRatio(
														&XAspect,&YAspect)) {
							AdjustAspect(&Width,&Height,XAspect,YAspect);
							if (Width!=pbmih->biWidth
									|| Height!=abs(pbmih->biHeight))
							hGlobal=ResizeImage((BITMAPINFO*)pbmih,pDib+Size,
																Width,Height);
						}
						if (hGlobal==NULL) {
							Size+=(pbmih->biWidth*pbmih->biBitCount+31)/32*4*
														abs(pbmih->biHeight);
							hGlobal=GlobalAlloc(GMEM_MOVEABLE | GMEM_SHARE,Size);
							CopyMemory(GlobalLock(hGlobal),pDib,Size);
							GlobalUnlock(hGlobal);
						}
						EmptyClipboard();
						SetClipboardData(CF_DIB,hGlobal);
						CloseClipboard();
					}
					CoTaskMemFree(pDib);
				} else
					MessageBox(fFullscreen?pFullscreen->GetHandle():hwnd,
						TEXT("݂̉摜擾ł܂B"),TEXT("߂"),
						MB_OK | MB_ICONEXCLAMATION);
			}
			return 0;

		case CM_RESET:
			DtvEngine.ResetEngine();
			return 0;

		case CM_DECODERPROPERTY:
			// ԈႢT2
			//DtvEngine.DisplayVideoDecoderProperty(hwnd);
			DtvEngine.DisplayVideoDecorderProperty(hwnd);
			return 0;

		case CM_OPTIONS:
			if (IsWindowEnabled(hwnd))
				OptionsDialog(hwnd);
			return 0;

		case CM_RECORD:
		case CM_RECORD_START:
		case CM_RECORD_STOP:
			if (LOWORD(wParam)==CM_RECORD_START) {
				if (fRecording)
					return 0;
			} else if (LOWORD(wParam)==CM_RECORD_STOP) {
				if (!fRecording)
					return 0;
			}
			if (fRecording) {
				DtvEngine.m_FileWriter.CloseFile();
				fRecording=false;
			} else {
				TCHAR szFileName[MAX_PATH];

				lstrcpy(szFileName,szRecordFileName);
				if (fAddRecordTime) {
					SYSTEMTIME st;

					if (lstrlen(szFileName)+15>=MAX_PATH) {
						MessageBox(hwnd,
							TEXT("t@Cētł܂B"),
									TEXT("߂"),MB_OK | MB_ICONEXCLAMATION);
						return 0;
					}
					GetLocalTime(&st);
					wsprintf(PathFindExtension(szFileName),
										TEXT("%04d%02d%02d_%02d%02d%02d%s"),
										st.wYear,st.wMonth,st.wDay,
										st.wHour,st.wMinute,st.wSecond,
										PathFindExtension(szRecordFileName));
				}
				if (!DtvEngine.m_FileWriter.OpenFile(szFileName,
												CNCachedFile::CNF_SHAREREAD)) {
					MessageBox(hwnd,TEXT("t@CJ܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
					return 0;
				}
				fRecording=true;
			}
			Status.UpdateItem(STATUS_ITEM_RECORD);
			return 0;

		case CM_RECORDFILENAME:
			if (IsWindowEnabled(hwnd)) {
				OPENFILENAME ofn;
				TCHAR szFileName[MAX_PATH];

				lstrcpy(szFileName,szRecordFileName);
				ofn.lStructSize=sizeof(OPENFILENAME);
				ofn.hwndOwner=fFullscreen?pFullscreen->GetHandle():hwnd;
				ofn.lpstrFilter=
					TEXT("TSt@C(*.ts)\0*.ts\0ׂẴt@C\0*.*\0");
				ofn.lpstrCustomFilter=NULL;
				ofn.nFilterIndex=1;
				ofn.lpstrFile=szFileName;
				ofn.nMaxFile=lengthof(szFileName);
				ofn.lpstrFileTitle=NULL;
				ofn.lpstrInitialDir=NULL;
				ofn.lpstrTitle=TEXT("ۑt@C");
				ofn.Flags=OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
				ofn.lpstrDefExt=TEXT("ts");
#if _WIN32_WINNT>=0x500
				ofn.pvReserved=NULL;
				ofn.dwReserved=0;
				ofn.FlagsEx=0;
#endif
				if (GetSaveFileName(&ofn))
					lstrcpy(szRecordFileName,szFileName);
			}
			return 0;

		case CM_ADDRECORDTIME:
			fAddRecordTime=!fAddRecordTime;
			CheckMenuItem(hmenuMain,CM_ADDRECORDTIME,
					MF_BYCOMMAND | (fAddRecordTime?MFS_CHECKED:MFS_UNCHECKED));
			return 0;

		case CM_EXIT:
			SendMessage(hwnd,WM_CLOSE,0,0);
			return 0;

		case CM_CHANNEL_UP:
		case CM_CHANNEL_DOWN:
			if (pNetworkRemocon!=NULL) {
				const CChannelList &List=pNetworkRemocon->GetChannelList();
				int i;
				int Channel,No;

				if (LOWORD(wParam)==CM_CHANNEL_UP) {
					int Min;

					Channel=1000;
					Min=1000;
					for (i=0;i<List.NumChannels();i++) {
						No=List.GetChannelNo(i);
						if (No>NetworkRemoconCurChannelNo && Channel>No)
							Channel=No;
						if (No<Min)
							Min=No;
					}
					if (Channel==1000)
						Channel=Min;
				} else {
					int Max;

					Channel=0;
					Max=0;
					for (i=0;i<List.NumChannels();i++) {
						No=List.GetChannelNo(i);
						if (No<NetworkRemoconCurChannelNo && Channel<No)
							Channel=No;
						if (No>Max)
							Max=No;
					}
					if (Channel==0)
						Channel=Max;
				}
				SendMessage(hwnd,WM_COMMAND,CM_CHANNELNO_FIRST+Channel-1,0);
			} else if (CurrentChannel>=0) {
				int Channel;
				int i;

				Channel=ChannelList.GetChannelNo(CurrentChannel)-1;
				for (i=0;i<12;i++) {
					if (LOWORD(wParam)==CM_CHANNEL_UP) {
						Channel=(Channel+1)%12;
					} else {
						if (Channel>0)
							Channel--;
						else
							Channel=11;
					}
					if (ChannelList.FindChannelNo(Channel+1)>=0)
						break;
				}
				SendMessage(hwnd,WM_COMMAND,CM_CHANNELNO_FIRST+Channel,0);
			} else {
				SendMessage(hwnd,WM_COMMAND,CM_CHANNEL_FIRST,0);
			}
			return 0;

		case CM_MENU:
			{
				POINT pt;

				pt.x=0;
				pt.y=0;
				ClientToScreen(hwndView,&pt);
				PopupMenu(pt.x,pt.y);
			}
			return 0;

		default:
			if (LOWORD(wParam)>=CM_CHANNELNO_FIRST
										&& LOWORD(wParam)<=CM_CHANNELNO_LAST) {
				int No=LOWORD(wParam)-CM_CHANNELNO_FIRST;

				if (pNetworkRemocon!=NULL) {
					if (fRecording && fConfirmRecChannelChange) {
						if (!RecChannelChangeDialog(hwnd))
							return 0;
					}
					pNetworkRemocon->SetChannel(No);
				} else {
					int Index=ChannelList.FindChannelNo(No+1);

					if (Index>=0)
						SendMessage(hwnd,WM_COMMAND,CM_CHANNEL_FIRST+Index,0);
				}
				return 0;
			}
			if (LOWORD(wParam)>=CM_CHANNEL_FIRST
										&& LOWORD(wParam)<=CM_CHANNEL_LAST) {
				int Channel=LOWORD(wParam)-CM_CHANNEL_FIRST,Space;

				if (fRecording && fConfirmRecChannelChange) {
					if (!RecChannelChangeDialog(hwnd))
						return 0;
				}
				Space=ChannelList.GetSpace(Channel);
				if (Space<0)
					Space=CurrentSpace;
				if ((Channel!=CurrentChannel || Space!=CurrentSpace)
						&& DtvEngine.SetChannel(Space,
									ChannelList.GetChannelIndex(Channel))) {
					CurrentSpace=Space;
					CurrentChannel=Channel;
					Status.UpdateItem(STATUS_ITEM_CHANNEL);
					CheckMenuRadioItem(hmenuMain,CM_CHANNEL_FIRST,
								CM_CHANNEL_FIRST+ChannelList.NumChannels()-1,
								CM_CHANNEL_FIRST+CurrentChannel,MF_BYCOMMAND);
					CheckMenuRadioItem(hmenuMain,CM_SPACE_FIRST,
								CM_SPACE_FIRST+NumSpaces-1,
								CM_SPACE_FIRST+CurrentSpace,MF_BYCOMMAND);
				}
				return 0;
			}
			if (LOWORD(wParam)>=CM_SERVICE_FIRST
										&& LOWORD(wParam)<=CM_SERVICE_LAST) {
				CurrentService=LOWORD(wParam)-CM_SERVICE_FIRST;
				DtvEngine.SetService(CurrentService);
				CheckMenuRadioItem(hmenuMain,CM_SERVICE_FIRST,
					CM_SERVICE_FIRST+GetMenuItemCount(
						GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_SERVICE))-1,
								CM_CHANNEL_FIRST+CurrentService,MF_BYCOMMAND);
				return 0;
			}
			if (LOWORD(wParam)>=CM_SPACE_FIRST
											&& LOWORD(wParam)<=CM_SPACE_LAST) {
				int Space=LOWORD(wParam)-CM_SPACE_FIRST;

				if (Space!=CurrentSpace
						&& DtvEngine.SetChannel(Space,
											ChannelList.GetChannelIndex(0))) {
					CurrentSpace=Space;
					CurrentChannel=0;
					Status.UpdateItem(STATUS_ITEM_CHANNEL);
					CheckMenuRadioItem(hmenuMain,CM_SPACE_FIRST,
								CM_SPACE_FIRST+NumSpaces-1,
								CM_SPACE_FIRST+CurrentSpace,MF_BYCOMMAND);
					CheckMenuRadioItem(hmenuMain,CM_CHANNEL_FIRST,
								CM_CHANNEL_FIRST+ChannelList.NumChannels()-1,
								CM_CHANNEL_FIRST+CurrentChannel,MF_BYCOMMAND);
				}
				return 0;
			}
		}
		return 0;

	case WM_SYSCOMMAND:
		switch (wParam) {
		case SC_MONITORPOWER:
			if (fNoMonitorLowPower)
				return TRUE;
			break;
		case SC_ABOUT:
			DialogBox(hInst,MAKEINTRESOURCE(IDD_ABOUT),hwnd,AboutDlgProc);
			return 0;
		}
		break;

	case WM_APP:
		{
			HMENU hmenu=GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_SERVICE);
			int NumServices=HIWORD(wParam);
			LPTSTR *ppszList=(LPTSTR*)lParam;
			int Count,i;

			Count=GetMenuItemCount(hmenu);
			for (i=Count-1;i>=0;i--)
				DeleteMenu(hmenu,i,MF_BYPOSITION);
			for (i=0;i<NumServices;i++) {
				AppendMenu(hmenu,MFT_STRING | MFS_ENABLED,CM_SERVICE_FIRST+i,
																ppszList[i]);
				delete [] ppszList[i];
			}
			delete [] ppszList;
			CurrentService=LOWORD(wParam);
			CheckMenuRadioItem(hmenuMain,CM_SERVICE_FIRST,
				CM_SERVICE_FIRST+NumServices-1,CM_CHANNEL_FIRST+CurrentService,
																MF_BYCOMMAND);
			if (pNetworkRemocon!=NULL)
				pNetworkRemocon->GetChannel(&GetChannelReciver);
		}
		return 0;

	case WM_APP+1:
		{
			const CChannelList &List=pNetworkRemocon->GetChannelList();

			NetworkRemoconCurChannelNo=List.GetChannelNo(wParam);
			CheckMenuRadioItem(hmenuMain,CM_CHANNELNO_FIRST,CM_CHANNELNO_LAST,
				CM_CHANNELNO_FIRST+NetworkRemoconCurChannelNo-1,MF_BYCOMMAND);
			Status.UpdateItem(STATUS_ITEM_CHANNEL);
		}
		return 0;

	case WM_DISPLAYCHANGE:
		if (fUseVMR9)
			DtvEngine.m_MediaViewer.DisplayModeChanged();
		break;

	case WM_CLOSE:
		if (fScreenSaverActive)
			SystemParametersInfo(SPI_SETSCREENSAVEACTIVE,TRUE,NULL,0);
		if (fPowerOffActiveOriginal)
			SystemParametersInfo(SPI_SETPOWEROFFACTIVE,TRUE,NULL,
								SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
		if (fLowPowerActiveOriginal)
			SystemParametersInfo(SPI_SETLOWPOWERACTIVE,TRUE,NULL,
								SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
		break;

	case WM_DESTROY:
		{
			if (pFullscreen!=NULL) {
				delete pFullscreen;
				pFullscreen=NULL;
			}
			if (pNetworkRemocon!=NULL) {
				delete pNetworkRemocon;
				pNetworkRemocon=NULL;
			}
			if (pKeyHook!=NULL) {
				delete pKeyHook;
				pKeyHook=NULL;
			}

			WINDOWPLACEMENT wc;

			wc.length=sizeof(WINDOWPLACEMENT);
			GetWindowPlacement(hwnd,&wc);
			WindowLeft=wc.rcNormalPosition.left;
			WindowTop=wc.rcNormalPosition.top;
			WindowWidth=wc.rcNormalPosition.right-wc.rcNormalPosition.left;
			WindowHeight=wc.rcNormalPosition.bottom-wc.rcNormalPosition.top;
			fWindowMaximize=wc.showCmd==SW_MAXIMIZE;

			KillTimer(hwnd,1);
			if (hDriverLib!=NULL) {
				DtvEngine.CloseEngine();
				FreeLibrary(hDriverLib);
			}
			if (!fUDPDriver && CurrentChannel>=0) {
				OldChannel=ChannelList.GetChannel(CurrentChannel);
				OldSpace=ChannelList.GetSpace(CurrentChannel);
			} else {
				OldChannel=0;
				OldSpace=-1;
			}
			DestroyMenu(hmenuMain);
			SaveSettings();
			PostQuitMessage(0);
		}
		return 0;

	default:
		if (pKeyHook!=NULL && pKeyHook->TranslateMessage(uMsg,wParam,lParam))
			return 0;
	}
	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}


static void ParseCommandLine(LPCWSTR pszCmdLine)
{
	LPWSTR *ppszArgList;
	int Args;

	ppszArgList=CommandLineToArgvW(pszCmdLine,&Args);
	if (ppszArgList!=NULL) {
		int i;

		for (i=0;i<Args;i++) {
			if (ppszArgList[i][0]=='/' || ppszArgList[i][0]=='-') {
				if (lstrcmpi(ppszArgList[i]+1,TEXT("d"))==0) {
					i++;
					if (i<Args)
						lstrcpyn(szTempDriverFileName,ppszArgList[i],
											lengthof(szTempDriverFileName));
				} else if (lstrcmpi(ppszArgList[i]+1,TEXT("nd"))==0) {
					fTempNoDescramble=true;
				} else if (lstrcmpi(ppszArgList[i]+1,TEXT("nr"))==0) {
					fUseNetworkRemoconCmd=true;
				}
			}
		}
		LocalFree(ppszArgList);
	}
}


#if 0
class CAppMutex {
	HANDLE m_hMutex;
	bool m_fAlreadyExists;
public:
	CAppMutex();
	~CAppMutex();
	bool AlreadyExists() const { return m_fAlreadyExists; }
};

CAppMutex::CAppMutex()
{
	m_hMutex=CreateMutex(NULL,TRUE,TEXT("HDUSTest Mutex"));
	m_fAlreadyExists=m_hMutex!=NULL && GetLastError()==ERROR_ALREADY_EXISTS;
}

CAppMutex::~CAppMutex()
{
	if (m_hMutex!=NULL) {
		if (!m_fAlreadyExists)
			ReleaseMutex(m_hMutex);
		CloseHandle(m_hMutex);
	}
}
#endif


int APIENTRY _tWinMain(HINSTANCE hInstance,HINSTANCE /*hPrevInstance*/,
												LPTSTR pszCmdLine,int nCmdShow)
{
#if 0
	CAppMutex Mutex;

	// Ñ`FbN
	if (Mutex.AlreadyExists()) {
		HWND hwnd;

		hwnd=FindWindow(MAIN_WINDOW_CLASS,TITLE_TEXT);
		if (IsWindow(hwnd)) {
			SetForeground(hwnd);
		} else {
			MessageBox(NULL,
				TEXT("HDUSTest ͊ɋNĂ܂B\r\n")
				TEXT("EBhEȂꍇ̓^XN}l[WɉBĂ܂̂\r\n")
				TEXT("IĂB"),TITLE_TEXT,
												MB_OK | MB_ICONEXCLAMATION);
		}
		return FALSE;
	}
#endif

	hInst=hInstance;

	TCHAR szModuleDir[MAX_PATH];

	GetModuleFileName(NULL,szModuleDir,MAX_PATH);
	lstrcpy(szIniFileName,szModuleDir);
	PathRenameExtension(szIniFileName,TEXT(".ini"));
	lstrcpy(szChannelListFileName,szModuleDir);
	PathRenameExtension(szChannelListFileName,TEXT(".ch"));
	*(PathFindFileName(szModuleDir)-1)='\0';
	PathCombine(szRecordFileName,szModuleDir,TEXT("Record.ts"));

	LoadSettings();
	if (pszCmdLine[0]!='\0')
		ParseCommandLine(pszCmdLine);

	if (szDriverFileName[0]=='\0')
		lstrcpy(szDriverFileName,TEXT("BonDriver_HDUS.dll"));
	if (szTempDriverFileName[0]=='\0')
		lstrcpy(szTempDriverFileName,szDriverFileName);
	if (!fTempNoDescramble)
		fTempNoDescramble=fNoDescramble;
	if (!fUseNetworkRemoconCmd)
		fUseNetworkRemoconCmd=fUseNetworkRemocon;
	if (szNetworkRemoconChFile[0]=='\0')
		lstrcpy(szNetworkRemoconChFile,TEXT("BonDriver_HDUS(HDUS).ChSet.txt"));

	WNDCLASS wc;

	wc.style=0;
	wc.lpfnWndProc=MainWndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hInstance=hInst;
	wc.hIcon=LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON));
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=(HBRUSH)(COLOR_3DFACE+1);
	wc.lpszMenuName=NULL;
	wc.lpszClassName=MAIN_WINDOW_CLASS;
	if (RegisterClass(&wc)==0) {
		return 0;
	}
	wc.style=CS_DBLCLKS;
	wc.lpfnWndProc=ViewWndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hInstance=hInst;
	wc.hIcon=NULL;
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=CreateSolidBrush(RGB(0,0,0));
	wc.lpszMenuName=NULL;
	wc.lpszClassName=VIEW_WINDOW_CLASS;
	if (RegisterClass(&wc)==0) {
		return 0;
	}
	wc.style=CS_DBLCLKS;
	wc.lpfnWndProc=VideoContainerWndProc;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hInstance=hInst;
	wc.hIcon=NULL;
	wc.hCursor=NULL;
	wc.hbrBackground=CreateSolidBrush(RGB(0,0,0));
	wc.lpszMenuName=NULL;
	wc.lpszClassName=VIDEO_CONTAINER_WINDOW_CLASS;
	if (RegisterClass(&wc)==0) {
		return 0;
	}
	CFullscreen::Init();
	if (!CStatusView::Init()) {
		return 0;
	}

	INITCOMMONCONTROLSEX iccex;

	iccex.dwSize=sizeof(INITCOMMONCONTROLSEX);
	iccex.dwICC=ICC_INTERNET_CLASSES;
	InitCommonControlsEx(&iccex);

	hwndMain=CreateWindowEx(fAlwaysOnTop?WS_EX_TOPMOST:0,MAIN_WINDOW_CLASS,
		TITLE_TEXT,
		WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN
			| (fWindowMaximize?WS_MAXIMIZE:0),
		WindowLeft,WindowTop,WindowWidth,WindowHeight,NULL,NULL,hInst,NULL);
	if (hwndMain==NULL) {
		MessageBox(NULL,TEXT("EBhE쐬ł܂B"),NULL,
														MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	ShowWindow(hwndMain,nCmdShow);
	UpdateWindow(hwndMain);

	hDriverLib=LoadLibrary(szTempDriverFileName);
	if (hDriverLib==NULL) {
		MessageBox(hwndMain,TEXT("hCo[hł܂B"),NULL,
												MB_OK | MB_ICONEXCLAMATION);
		LoadChannelList(&ChannelList,szChannelListFileName);
	} else {
		LPCTSTR pszName;

		DtvEngine.m_MediaViewer.SetVMR9(fUseVMR9);
		if (DtvEngine.OpenEngine(&DtvEngineHandler,hwndVideoContainer,hwndMain,
											hDriverLib,!fTempNoDescramble)) {
			DtvEngine.EnablePreview();
			DtvEngine.SetVolume(LevelToDeciBel(CurrentVolume));
		}
		pszName=DtvEngine.m_BonSrcDecoder.GetSpaceName(0);
		fUDPDriver=pszName!=NULL && _tcsncmp(pszName,TEXT("UDP/"),4)==0;
		if (fUDPDriver) {
			CurrentChannel=0;
		} else {
			LoadChannelList(&ChannelList,szChannelListFileName);
			ChannelList.SetChannelOffset(FIRST_CHANNEL);
		}
		if (ChannelList.NumChannels()==0) {
			int i;

			for (i=0;(pszName=DtvEngine.m_BonSrcDecoder.GetChannelName(0,i))
																!=NULL;i++) {
				if (fUDPDriver)
					ChannelList.AddChannel(0,i,i+1,pszName);
				else
					ChannelList.AddChannel(-1,FIRST_CHANNEL+i,i+1,pszName);
			}
		}
		SetChannelMenu(GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_CHANNEL));
		SetSpaceMenu(GetSubMenu(GetSubMenu(hmenuMain,0),MENU_POS_SPACE));
		if (fUseVMR9)
			EnableMenuItem(hmenuMain,CM_COPY,MF_BYCOMMAND | MFS_ENABLED);
		SetTimer(hwndMain,TIMER_ID_UPDATE,500,NULL);
	}

	if (!fNoKeyHook && !fNoRemoteController) {
		pKeyHook=new CKeyHook;
		pKeyHook->BeginHook();
	}

	if (!fNoRemoteController) {
		hAccel=LoadAccelerators(hInst,
							MAKEINTRESOURCE(fNoKeyHook?IDA_ACCEL:IDA_ACCEL2));
	} else
		hAccel=NULL;

	if (fUseNetworkRemoconCmd && fUDPDriver && NetworkRemoconPort>0)
		InitNetworkRemocon();

	SetDisplayStatus();

	Status.SetSingleText(NULL);

	if (fRestoreChannel && OldChannel>0) {
		int i;

		for (i=0;i<ChannelList.NumChannels();i++) {
			if (ChannelList.GetChannel(i)==OldChannel
					&& ChannelList.GetSpace(i)==OldSpace) {
				SendMessage(hwndMain,WM_COMMAND,CM_CHANNEL_FIRST+i,0);
				break;
			}
		}
	}

	MSG msg;

	while (GetMessage(&msg,NULL,0,0)) {
		if (hAccel==NULL || !TranslateAccelerator(hwndMain,hAccel,&msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}
